# Ignite UI for Web Components Maps - from Infragistics

[Ignite UI for Web Components](https://www.infragistics.com/products/ignite-ui-webcomponents) is a complete set of UI Widgets, Components extending the browser's native capabilities by Infragistics. Ignite UI for Web Components is designed to enable developers to build the most modern, high-performance HTML5 & JavaScript apps for modern desktop browsers, mobile experiences and progressive web apps (PWA’s) with native custom elements.

## View Samples and Documentation

This package provides the Geographic Map components for Ignite UI for React:

[Bubble Map](https://www.infragistics.com/webcomponentssite/components/geo-map-type-scatter-bubble-series), [Symbol Map](https://www.infragistics.com/webcomponentssite/components/geo-map-type-scatter-symbol-series), [High Density Map](https://www.infragistics.com/webcomponentssite/components/geo-map-type-scatter-density-series), [Area Map](https://www.infragistics.com/webcomponentssite/components/geo-map-type-scatter-area-series), [Contour Map](https://www.infragistics.com/webcomponentssite/components/geo-map-type-scatter-contour-series), [Polygon Map](https://www.infragistics.com/webcomponentssite/components/geo-map-type-shape-polygon-series), [Polyline Map](https://www.infragistics.com/webcomponentssite/components/geo-map-type-shape-polyline-series), [Heat Map](https://www.infragistics.com/webcomponentssite/components/geo-map-display-heat-imagery), [Imagery Tiles](https://www.infragistics.com/webcomponentssite/components/geo-map-display-esri-imagery)

## NPM Package

You can include Ignite UI for WebComponents Maps in your project using this `npm` command:

`npm install --save igniteui-webcomponents-maps igniteui-webcomponents-charts igniteui-webcomponents-core`

## License
This is a commercial product, requiring a valid paid-for license for use. This license details can by found [here](http://www.infragistics.com/legal/ultimate/license/)

To acquire a license for usage, please register for a trial and acquire a license at [Infragistics.com](https://www.infragistics.com).

© Copyright 2023 Infragistics. All Rights Reserved. The Infragistics Ultimate license & copyright applies to this distribution. For information on that license, please go to our website [here](https://www.infragistics.com/legal/license).
