/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Series } from "igniteui-webcomponents-charts";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { typeCast, Number_$type, runOn, delegateRemove, delegateCombine, markType, TypeRegistrar } from "igniteui-webcomponents-core";
import { SeriesView } from "igniteui-webcomponents-charts";
import { SeriesViewer } from "igniteui-webcomponents-charts";
import { PropertyMetadata } from "igniteui-webcomponents-core";
import { PlatformConstants } from "igniteui-webcomponents-core";
import { isNaN_ } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export let GeographicMapSeriesHost = /*@__PURE__*/ (() => {
    class GeographicMapSeriesHost extends Series {
        oh() {
            super.oh();
            if (this.t5 != null) {
                this.t5.oh();
            }
        }
        constructor() {
            super();
            this.t3 = null;
            this.t5 = this.t4();
        }
        get_er() {
            return true;
        }
        jv(a, b) {
            let c = this.lw(b);
            if (c == "LatitudeMemberPath") {
                c = "YMemberPath";
            }
            if (c == "LongitudeMemberPath") {
                c = "XMemberPath";
            }
            return this.t5.jv(a, b);
        }
        dt(a, b, c, d) {
            return this.t5.dt(a, b, c, d);
        }
        ag() {
            return this.t5.ag();
        }
        bg() {
            return this.t5;
        }
        get t5() {
            return this.t3;
        }
        set t5(a) {
            let b = this.t5 != a;
            if (b) {
                this.t3 = a;
                this.ua();
            }
        }
        get_hasMarkers() {
            return this.t5.hasMarkers;
        }
        ua() {
            if (this.t3 != null) {
                let hostedSeries_ = this.t3;
                hostedSeries_.externalObject = TypeRegistrar.createFromInternal(hostedSeries_, PlatformConstants.Prefix, PlatformConstants.Postfix);
                hostedSeries_.externalObject._implementation = hostedSeries_;
            }
            this.ns(this.t5);
            this.t6.b5();
        }
        c0(a, b, c) {
            return this.c2(this.t5, a, b, c);
        }
        c1(a, b, c) {
            return this.c3(this.t5, a, b, c);
        }
        js(a) {
            return this.jy(this.t5, a);
        }
        jg(a, b) {
            return this.t5.jg(a, b);
        }
        je(a, b) {
            return this.t5.je(a, b);
        }
        ia(a, b, c) {
            return this.t5.ia(a, b, c);
        }
        tj(a, b, c) {
            return this.t5.tj(a, b, c);
        }
        tu(a) {
            return this.t5.tu(a);
        }
        ak(a) {
            return this.t5.ak(a);
        }
        tv(a) {
            return this.t5.tv(a);
        }
        al(a) {
            return this.t5.al(a);
        }
        tw(a) {
            return this.t5.tw(a);
        }
        tx(a) {
            return this.t5.tx(a);
        }
        h6(a, b, c) {
            return this.t5.h6(a, b, c);
        }
        tf(a, b, c) {
            return this.t5.tf(a, b, c);
        }
        h8(a, b, c) {
            return this.ia(a, b, c);
        }
        th(a, b, c) {
            return this.t5.th(a, b, c);
        }
        tk(a, b, c) {
            return this.t5.tk(a, b, c);
        }
        ib(a, b, c) {
            return this.t5.ib(a, b, c);
        }
        tg(a, b, c) {
            return this.t5.tg(a, b, c);
        }
        h7(a, b, c) {
            return this.t5.h7(a, b, c);
        }
        ti(a, b, c) {
            return this.t5.ti(a, b, c);
        }
        h9(a, b, c) {
            return this.t5.h9(a, b, c);
        }
        ja(a) {
            return this.t5.ja(a);
        }
        h1() {
            return this.t5.h1();
        }
        hx(a) {
            return this.t5.hx(a);
        }
        jt(a) {
            return this.t5.jt(a);
        }
        cd() {
            return new HostSeriesView(this);
        }
        o2(a) {
            super.o2(a);
            this.t6 = typeCast(HostSeriesView.$, a);
        }
        get t7() {
            return this.c(GeographicMapSeriesHost.uc);
        }
        set t7(a) {
            this.h(GeographicMapSeriesHost.uc, a);
        }
        pa(a, b, c, d) {
            super.pa(a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    this.t5.cv = this.cv;
                    if (c != null) {
                        c.o6(this.t5);
                    }
                    if (d != null) {
                        this.cv.ls(this.t5);
                    }
                    this.t5.pd(this.ty);
                    this.t5.index = this.index;
                    this.n3(this.t5);
                    this.jm = this.t5.jm;
                    let e = typeCast(SeriesViewer.$, c);
                    if (e != null) {
                        e.actualWindowRectChanged = delegateRemove(e.actualWindowRectChanged, runOn(this, this.ub));
                    }
                    if (this.cv != null) {
                        let f = this.cv;
                        f.actualWindowRectChanged = delegateCombine(f.actualWindowRectChanged, runOn(this, this.ub));
                    }
                    this.t9();
                    break;
                case "SyncLink":
                    this.t5.co = this.co;
                    break;
                case "VisibleFromScale":
                    this.t9();
                    break;
                case "Index":
                    this.t5.index = this.index;
                    break;
                case "ItemsSource":
                    this.t6.b6();
                    break;
                case "Resolution":
                    this.t6.cd();
                    break;
                case "TransitionDuration":
                    this.t6.cg();
                    break;
                case "Opacity":
                    this.t6.ca();
                    break;
                case "Visibility":
                    let hs_ = this.t5;
                    let v_ = this._visibility;
                    hs_.visibility = v_;
                    break;
                case "MouseOverEnabled":
                    this.t5.fl = this.fl;
                    break;
                case "ExpectFunctions":
                    this.t5.expectFunctions = this.expectFunctions;
                    break;
                case "Thickness":
                    this.t6.cf();
                    break;
                case "Brush":
                    this.t6.b4();
                    break;
                case "Outline":
                    this.t6.cc();
                    break;
                case "ActualBrush":
                    this.t6.b1();
                    break;
                case "ActualOutline":
                    this.t6.b2();
                    break;
                case "MarkerFillOpacity":
                    if (!isNaN_(this.il)) {
                        this.t6.b9();
                    }
                    break;
                case "AreaFillOpacity":
                    if (!isNaN_(this.hq)) {
                        this.t6.b3();
                    }
                    break;
                case "OutlineMode":
                    this.t6.cb();
                    break;
                case "ShowDefaultTooltip":
                    this.t6.ce();
                    break;
                case "Title":
                    this.t5.title = this.title;
                    break;
                case "LegendItemBadgeMode":
                    this.t6.b7();
                    break;
                case "LegendItemBadgeShape":
                    this.t6.b8();
                    break;
                case "Legend":
                    this.t5.legend = this.legend;
                    this.cg.av();
                    break;
            }
        }
        t9() {
            if (this.cv == null || this.t5 == null) {
                return;
            }
            if (!isNaN_(this.t7)) {
                if (this.cv.tr.width > this.t7) {
                    let hs_ = this.t5;
                    let v_ = 1;
                    hs_.visibility = v_;
                }
                else {
                    let hs2_ = this.t5;
                    let v2_ = 0;
                    hs2_.visibility = v2_;
                }
            }
        }
        ub(a, b) {
            this.t9();
        }
        pr(a) {
            super.pr(a);
            if (this.t5 != null) {
                this.t5.pr(a);
            }
        }
        pq(a, b, c, d, e) {
            if (this.t5 != null) {
                this.t5.pq(a, b, c, d, e);
            }
        }
        au(a, b) {
            return this.t5.au(a, b);
        }
        qa() {
            super.qa();
            this.t5.qa();
        }
        get_coercionMethods() {
            return this._coercionMethods;
        }
        set_coercionMethods(a) {
            this._coercionMethods = a;
            this.t5.coercionMethods = a;
        }
        n2(a) {
            super.n2(a);
            if (this.t5 != null) {
                let b = this.t5.jr();
                this.nn(a, b);
            }
        }
    }
    GeographicMapSeriesHost.$t = /*@__PURE__*/ markType(GeographicMapSeriesHost, 'GeographicMapSeriesHost', Series.$);
    GeographicMapSeriesHost.uc = /*@__PURE__*/ DependencyProperty.i("VisibleFromScale", Number_$type, GeographicMapSeriesHost.$, /*@__PURE__*/ new PropertyMetadata(2, 1, (a, b) => {
        let c = a;
        c.raisePropertyChanged("VisibleFromScale", b.oldValue, b.newValue);
    }));
    return GeographicMapSeriesHost;
})();
/**
 * @hidden
 */
export let HostSeriesView = /*@__PURE__*/ (() => {
    class HostSeriesView extends SeriesView {
        constructor(a) {
            super(a);
            this.b0 = null;
            this.b0 = a;
        }
        at(a, b) {
            super.at(a, b);
        }
        b5() {
            this.b0.t2 = 1;
            this.b0.t5.t2 = 0;
            this.b0.t5.itemsSource = this.b0.itemsSource;
            this.b0.t5.index = this.b0.index;
            this.b0.t5.sy = this.b0.sy;
            this.b0.t5.s4 = this.b0.sy;
            this.b0.t5.b9 = this.b0.b9;
            this.b0.t5.ip = this.b0.ip;
            this.b0.t5.jj = this.b0.jj;
            this.b0.t5._opacity = this.b0._opacity;
            this.b0.t5.iv = this.b0.iv;
            this.b0.t5.hq = this.b0.hq;
            this.b0.t5.il = this.b0.il;
            this.b0.t5.fz = this.b0.fz;
            this.b0.t5.legendItemBadgeShape = this.b0.legendItemBadgeShape;
            this.b0.t5.a6 = this.b0.a6;
        }
        b6() {
            this.b0.t5.itemsSource = this.b0.itemsSource;
        }
        cd() {
            this.b0.t5.ip = this.b0.ip;
        }
        cg() {
            this.b0.t5.jj = this.b0.jj;
        }
        ca() {
            this.b0.t5._opacity = this.b0._opacity;
        }
        cf() {
            this.b0.t5.iv = this.b0.iv;
        }
        b4() {
            this.b0.t5.sy = this.b0.sy;
        }
        cc() {
            this.b0.t5.s4 = this.b0.s4;
        }
        b1() {
            this.b0.t5.sy = this.b0.su;
        }
        b2() {
            this.b0.t5.s4 = this.b0.sx;
        }
        b7() {
            this.b0.t5.a6 = this.b0.a6;
        }
        b8() {
            this.b0.t5.legendItemBadgeShape = this.b0.legendItemBadgeShape;
        }
        b3() {
            this.b0.t5.hq = this.b0.hq;
        }
        b9() {
            this.b0.t5.il = this.b0.il;
        }
        cb() {
            this.b0.t5.b9 = this.b0.b9;
        }
        ce() {
            this.b0.t5.fz = this.b0.fz;
        }
    }
    HostSeriesView.$t = /*@__PURE__*/ markType(HostSeriesView, 'HostSeriesView', SeriesView.$);
    return HostSeriesView;
})();
