/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { HostSeriesView } from "./HostSeriesView";
import { BubbleSeries } from "igniteui-webcomponents-charts";
import { GeographicMarkerSeries } from "./GeographicMarkerSeries";
import { markType, enumGetBox, runOn, delegateCombine, delegateRemove, markDep } from "igniteui-webcomponents-core";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { SizeScale } from "igniteui-webcomponents-charts";
import { BrushScale } from "igniteui-webcomponents-charts";
import { ScatterItemSearchMode_$type } from "igniteui-webcomponents-charts";
import { PropertyMetadata } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export let GeographicProportionalSymbolSeriesView = /*@__PURE__*/ (() => {
    class GeographicProportionalSymbolSeriesView extends HostSeriesView {
        constructor(a) {
            super(a);
            this.ch = null;
            this.ch = a;
        }
        au() {
            super.au();
            if (!this.q) {
            }
        }
        b5() {
            super.b5();
            let a = this.ch.t5;
            a.xn = this.ch.v4;
            a.xv = this.ch.v2;
            a.uc = this.ch.uf;
            a.uy = this.ch.uv;
            a.uh = this.ch.ug;
            a.zv = this.ch.vo;
            a.aal = this.ch.v9;
            a.zl = this.ch.vg;
            a.aab = this.ch.v0;
            a.z6 = this.ch.vs;
            a.zi = this.ch.vd;
            a.zt = this.ch.vk;
            a.zu = this.ch.vn;
            a.z0 = this.ch.vq;
            a.zz = this.ch.vp;
        }
        cq() {
            this.ch.t5.xn = this.ch.v4;
        }
        cp() {
            this.ch.t5.xv = this.ch.v2;
        }
        cv() {
            this.ch.t5.uc = this.ch.uf;
        }
        ct() {
            this.ch.t5.uy = this.ch.uv;
        }
        cu() {
            this.ch.t5.uh = this.ch.ug;
        }
        cw() {
            this.ch.t5.w3 = this.ch.uh;
        }
        cy() {
            this.ch.t5.xAxis = this.ch.cv.ue;
        }
        cz() {
            this.ch.t5.yAxis = this.ch.cv.ug;
        }
        cx() {
            let a = this.ch.t5;
            if (this.ch.cv == null) {
                a.xAxis = null;
                a.yAxis = null;
                return;
            }
            a.xAxis = this.ch.cv.ue;
            a.yAxis = this.ch.cv.ug;
        }
        cr() {
            this.ch.t5.ve = this.ch.u9;
        }
        cs() {
            this.ch.t5.vf = this.ch.va;
        }
        c0() {
            this.ch.t5.aal = this.ch.v9;
        }
        c1() {
            this.ch.t5.zl = this.ch.vg;
            this.ch.t5.zv = this.ch.vo;
        }
        cl() {
            this.ch.t5.aab = this.ch.v0;
        }
        cj() {
            this.ch.t5.zi = this.ch.vd;
            this.ch.t5.zt = this.ch.vk;
            this.ch.t5.zu = this.ch.vn;
            this.ch.t5.z0 = this.ch.vq;
            this.ch.t5.zz = this.ch.vp;
        }
        ci() {
            this.ch.t5.z6 = this.ch.vs;
        }
        c2() {
            this.ch.t5.zv = this.ch.vo;
        }
        ck() {
            this.ch.t5.zt = this.ch.vk;
        }
        co() {
            this.ch.t5.zu = this.ch.vn;
        }
        cn() {
            this.ch.t5.z0 = this.ch.vq;
        }
        cm() {
            this.ch.t5.zz = this.ch.vp;
        }
    }
    GeographicProportionalSymbolSeriesView.$t = /*@__PURE__*/ markType(GeographicProportionalSymbolSeriesView, 'GeographicProportionalSymbolSeriesView', HostSeriesView.$);
    return GeographicProportionalSymbolSeriesView;
})();
/**
 * @hidden
 */
export let GeographicProportionalSymbolSeries = /*@__PURE__*/ (() => {
    class GeographicProportionalSymbolSeries extends GeographicMarkerSeries {
        bc() {
            return new GeographicProportionalSymbolSeries();
        }
        get_dy() {
            return true;
        }
        constructor() {
            super();
            this.ve = null;
            this.vj = false;
            this.vi = false;
            this.assigningScatterStyle = null;
            this.assigningScatterMarkerStyle = null;
            this.ab = GeographicProportionalSymbolSeries.$;
        }
        cd() {
            return new GeographicProportionalSymbolSeriesView(this);
        }
        o2(a) {
            super.o2(a);
            this.vh = a;
        }
        ir() {
            return 0.7;
        }
        t4() {
            return new BubbleSeries();
        }
        get_et() {
            return true;
        }
        pa(a, b, c, d) {
            super.pa(a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    this.vh.cx();
                    break;
                case GeographicProportionalSymbolSeries.$$p[9]:
                    this.vh.cq();
                    break;
                case GeographicProportionalSymbolSeries.$$p[8]:
                    this.vh.cp();
                    break;
                case "XAxis":
                    this.vh.cy();
                    break;
                case "YAxis":
                    this.vh.cz();
                    break;
                case GeographicProportionalSymbolSeries.$$p[13]:
                    this.vh.c0();
                    break;
                case GeographicProportionalSymbolSeries.$$p[14]:
                    this.vh.c1();
                    break;
                case GeographicProportionalSymbolSeries.$$p[15]:
                    this.vh.c2();
                    break;
                case GeographicProportionalSymbolSeries.$$p[7]:
                    this.vh.cl();
                    break;
                case GeographicProportionalSymbolSeries.$$p[0]:
                    this.vh.ci();
                    break;
                case GeographicProportionalSymbolSeries.$$p[1]:
                    this.vh.cj();
                    break;
                case GeographicProportionalSymbolSeries.$$p[2]:
                    this.vh.ck();
                    break;
                case GeographicProportionalSymbolSeries.$$p[12]:
                    this.vh.co();
                    break;
                case GeographicProportionalSymbolSeries.$$p[11]:
                    this.vh.cn();
                    break;
                case GeographicProportionalSymbolSeries.$$p[10]:
                    this.vh.cm();
                    break;
                case GeographicProportionalSymbolSeries.$$p[4]:
                    this.t5.wk = this.vm;
                    this.vj = this.vm;
                    if (this.vm) {
                        let e = this.t5;
                        e.assigningScatterStyle = delegateCombine(e.assigningScatterStyle, runOn(this, this.we));
                    }
                    else {
                        let f = this.t5;
                        f.assigningScatterStyle = delegateRemove(f.assigningScatterStyle, runOn(this, this.we));
                    }
                    break;
                case GeographicProportionalSymbolSeries.$$p[3]:
                    this.t5.wj = this.vl;
                    this.vi = this.vl;
                    if (this.vm) {
                        let g = this.t5;
                        g.assigningScatterMarkerStyle = delegateCombine(g.assigningScatterMarkerStyle, runOn(this, this.wd));
                    }
                    else {
                        let h = this.t5;
                        h.assigningScatterMarkerStyle = delegateRemove(h.assigningScatterMarkerStyle, runOn(this, this.wd));
                    }
                    break;
                case GeographicProportionalSymbolSeries.$$p[5]:
                    this.t5.v3 = this.vf;
                    break;
                case GeographicProportionalSymbolSeries.$$p[6]:
                    this.t5.w2 = this.vr;
                    break;
            }
        }
        we(a, b) {
            if (this.assigningScatterStyle != null) {
                this.assigningScatterStyle(this, b);
            }
        }
        wd(a, b) {
            if (this.assigningScatterMarkerStyle != null) {
                this.assigningScatterMarkerStyle(this, b);
            }
        }
    }
    GeographicProportionalSymbolSeries.$t = /*@__PURE__*/ markType(GeographicProportionalSymbolSeries, 'GeographicProportionalSymbolSeries', GeographicMarkerSeries.$);
    GeographicProportionalSymbolSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, GeographicProportionalSymbolSeries, 'raisePropertyChanged', ['FillMemberPath:vs:wf', [2], 'FillScale:vd:wg', [BrushScale.$], 'FillScaleUseGlobalValues:vk:wh', [0, false], 'IsCustomScatterMarkerStyleAllowed:vl:wi', [0, false], 'IsCustomScatterStyleAllowed:vm:wj', [0, false], 'ItemSearchMode:vf:wk', [ScatterItemSearchMode_$type, /*@__PURE__*/ enumGetBox(ScatterItemSearchMode_$type, 0)], 'ItemSearchThreshold:vr:wl', [1, 10000], 'LabelMemberPath:v0:wm', [2], 'LatitudeMemberPath:v2:wn', [2, null], 'LongitudeMemberPath:v4:wo', [2, null], 'MarkerBrushBrightness:vp:wp', [1, NaN], 'MarkerOutlineBrightness:vq:wq', [1, NaN], 'MarkerOutlineUsesFillScale:vn:wr', [0, false], 'RadiusMemberPath:v9:ws', [2, null], 'RadiusScale:vg:wt', [SizeScale.$], 'RadiusScaleUseGlobalValues:vo:wu', [0, false]]);
    return GeographicProportionalSymbolSeries;
})();
