/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { GeographicMapSeriesHost } from "./GeographicMapSeriesHost";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { ShapeItemSearchMode_$type } from "igniteui-webcomponents-charts";
import { enumGetBox, runOn, delegateCombine, delegateRemove, markType, markDep } from "igniteui-webcomponents-core";
import { PropertyMetadata } from "igniteui-webcomponents-core";
import { HostSeriesView } from "./HostSeriesView";
/**
 * @hidden
 */
export let GeographicShapeSeriesBase = /*@__PURE__*/ (() => {
    class GeographicShapeSeriesBase extends GeographicMapSeriesHost {
        constructor() {
            super(...arguments);
            this.ul = false;
            this.uk = false;
            this.assigningShapeStyle = null;
            this.assigningShapeMarkerStyle = null;
            this.uh = null;
            this.uj = false;
        }
        cd() {
            return new GeographicShapeSeriesBaseView(this);
        }
        o2(a) {
            super.o2(a);
            this.ug = a;
        }
        get_et() {
            return true;
        }
        get_dv() {
            return true;
        }
        pa(a, b, c, d) {
            super.pa(a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    this.ug.ci();
                    break;
                case "ShapeMemberPath":
                    this.ug.ck();
                    break;
                case GeographicShapeSeriesBase.$$p[5]:
                    this.ug.cj();
                    break;
                case GeographicShapeSeriesBase.$$p[1]:
                    this.t5.u4 = this.un;
                    this.ul = this.un;
                    if (this.un) {
                        let e = this.t5;
                        e.assigningShapeStyle = delegateCombine(e.assigningShapeStyle, runOn(this, this.u1));
                    }
                    else {
                        let f = this.t5;
                        f.assigningShapeStyle = delegateRemove(f.assigningShapeStyle, runOn(this, this.u1));
                    }
                    break;
                case GeographicShapeSeriesBase.$$p[0]:
                    this.t5.u3 = this.um;
                    this.uk = this.um;
                    if (this.un) {
                        let g = this.t5;
                        g.assigningShapeMarkerStyle = delegateCombine(g.assigningShapeMarkerStyle, runOn(this, this.u0));
                    }
                    else {
                        let h = this.t5;
                        h.assigningShapeMarkerStyle = delegateRemove(h.assigningShapeMarkerStyle, runOn(this, this.u0));
                    }
                    break;
                case GeographicShapeSeriesBase.$$p[2]:
                    this.t5.ul = this.uf;
                    break;
                case GeographicShapeSeriesBase.$$p[3]:
                    this.t5.vl = this.up;
                    break;
                case GeographicShapeSeriesBase.$$p[4]:
                    this.t5.vm = this.uq;
                    break;
                case "ShapefileDataSource":
                    if (c != null) {
                        let i = c;
                        if (this.uj) {
                            i.importCompleted = delegateRemove(i.importCompleted, runOn(this, this.u2));
                        }
                    }
                    if (d != null) {
                        let j = d;
                        if (j.count > 0) {
                            this.u3();
                            break;
                        }
                        this.uj = true;
                        j.importCompleted = delegateCombine(j.importCompleted, runOn(this, this.u2));
                    }
                    break;
            }
        }
        u1(a, b) {
            if (this.assigningShapeStyle != null) {
                this.assigningShapeStyle(this, b);
            }
        }
        u0(a, b) {
            if (this.assigningShapeMarkerStyle != null) {
                this.assigningShapeMarkerStyle(this, b);
            }
        }
        u2(a, b) {
            this.u3();
        }
        u3() {
            let sds_ = this.ui;
            let ext_ = sds_.externalObject;
            this.itemsSource = (ext_.getPointData());
        }
        get ui() {
            return this.uh;
        }
        set ui(a) {
            let b = this.uh;
            this.uh = a;
            if (b != this.uh) {
                this.raisePropertyChanged("ShapefileDataSource", b, this.uh);
            }
        }
        get_gg() {
            return true;
        }
        set_gg(a) {
            super.set_gg(a);
        }
    }
    GeographicShapeSeriesBase.$t = /*@__PURE__*/ markType(GeographicShapeSeriesBase, 'GeographicShapeSeriesBase', GeographicMapSeriesHost.$);
    GeographicShapeSeriesBase.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, GeographicShapeSeriesBase, 'raisePropertyChanged', ['IsCustomShapeMarkerStyleAllowed:um:u4', [0, false], 'IsCustomShapeStyleAllowed:un:u5', [0, false], 'ItemSearchMode:uf:u6', [ShapeItemSearchMode_$type, /*@__PURE__*/ enumGetBox(ShapeItemSearchMode_$type, 0)], 'ItemSearchPointsThreshold:up:u7', [1, 10000], 'ItemSearchThreshold:uq:u8', [1, 10000], 'ShapeFilterResolution:uo:u9', [1, 2], 'ShapeMemberPath:uy:va', [2, "points"]]);
    return GeographicShapeSeriesBase;
})();
/**
 * @hidden
 */
export let GeographicShapeSeriesBaseView = /*@__PURE__*/ (() => {
    class GeographicShapeSeriesBaseView extends HostSeriesView {
        constructor(a) {
            super(a);
            this.ch = null;
            this.ch = a;
        }
        b5() {
            super.b5();
            this.ch.t5.vy = this.ch.uy;
        }
        ci() {
            let a = this.ch.t5;
            if (this.ch.cv == null) {
                a.uf = null;
                a.uh = null;
                return;
            }
            a.uf = this.ch.cv.ue;
            a.uh = this.ch.cv.ug;
        }
        ck() {
            this.ch.t5.vy = this.ch.uy;
        }
        cj() {
            this.ch.t5.vi = this.ch.uo;
        }
    }
    GeographicShapeSeriesBaseView.$t = /*@__PURE__*/ markType(GeographicShapeSeriesBaseView, 'GeographicShapeSeriesBaseView', HostSeriesView.$);
    return GeographicShapeSeriesBaseView;
})();
