/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { GeographicShapeSeriesBaseView } from "./GeographicShapeSeriesBaseView";
import { GeographicShapeSeriesBase } from "./GeographicShapeSeriesBase";
import { Brush } from "igniteui-webcomponents-core";
import { Defaults } from "igniteui-webcomponents-charts";
import { MarkerType_$type } from "igniteui-webcomponents-charts";
import { MarkerFillMode_$type } from "igniteui-webcomponents-charts";
import { ScatterPolygonSeries } from "igniteui-webcomponents-charts";
import { markType, runOn, delegateCombine, typeCast, enumGetBox, markDep } from "igniteui-webcomponents-core";
import { StyleSelector } from "igniteui-webcomponents-charts";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { Style } from "igniteui-webcomponents-core";
import { MarkerOutlineMode_$type } from "igniteui-webcomponents-charts";
import { DataTemplate } from "igniteui-webcomponents-core";
import { CollisionAvoidanceType_$type } from "igniteui-webcomponents-charts";
import { PropertyMetadata } from "igniteui-webcomponents-core";
import { DeviceUtils } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export let GeographicShapeSeriesView = /*@__PURE__*/ (() => {
    class GeographicShapeSeriesView extends GeographicShapeSeriesBaseView {
        constructor(a) {
            super(a);
            this.cl = null;
            this.cl = a;
            if (!this.q) {
                this.cl.uy = "points";
            }
        }
        au() {
            super.au();
            if (!this.q) {
                this.cl.wi = Defaults.aj;
                this.cl.iv = Defaults.p;
                this.cl.vh = Defaults.o;
                this.cl.ve = Defaults.d;
                this.cl.vc = Defaults.a;
            }
        }
        b5() {
            super.b5();
            this.cl.t5.yg = this.cl.wk;
            this.cl.t5.w9 = this.cl.vf;
            this.cl.t5.xv = this.cl.v0;
            this.cl.t5.xc = this.cl.vh;
            this.cl.t5.wv = this.cl.vb;
        }
        cq() {
            this.cl.t5.xv = this.cl.v0;
        }
        cs() {
            this.cl.t5.xc = this.cl.vh;
        }
        cn() {
            this.cl.t5.wv = this.cl.vb;
        }
        cr() {
            this.cl.t5.w4 = this.cl.ve;
        }
        cm() {
            this.cl.t5.yc = this.cl.wh;
        }
        co() {
            this.cl.t5.yd = this.cl.wi;
        }
        cp() {
            this.cl.t5.yf = this.cl.wj;
        }
        ct() {
            this.cl.t5.w9 = this.cl.vf;
        }
        cu() {
            this.cl.t5.yg = this.cl.wk;
        }
    }
    GeographicShapeSeriesView.$t = /*@__PURE__*/ markType(GeographicShapeSeriesView, 'GeographicShapeSeriesView', GeographicShapeSeriesBaseView.$);
    return GeographicShapeSeriesView;
})();
/**
 * @hidden
 */
export let GeographicShapeSeries = /*@__PURE__*/ (() => {
    class GeographicShapeSeries extends GeographicShapeSeriesBase {
        bc() {
            return new GeographicShapeSeries();
        }
        get_e4() {
            return true;
        }
        constructor() {
            super();
            this.styleShape = null;
            this.ab = GeographicShapeSeries.$;
        }
        cd() {
            return new GeographicShapeSeriesView(this);
        }
        o2(a) {
            super.o2(a);
            this.vg = a;
        }
        t4() {
            let a = new ScatterPolygonSeries();
            a.styleShape = delegateCombine(a.styleShape, runOn(this, this.vx));
            a.propertyUpdated = delegateCombine(a.propertyUpdated, runOn(this, this.vy));
            return a;
        }
        vx(a, b) {
            if (this.styleShape != null) {
                this.styleShape(this, b);
            }
        }
        vy(a, b) {
            let c = typeCast(ScatterPolygonSeries.$, this.t5);
            if (c == null) {
                return;
            }
        }
        ht() {
            return this.vh;
        }
        s1() {
            return this.wf;
        }
        s2() {
            return this.wg;
        }
        qx() {
            return this.vz;
        }
        ky() {
            let a = typeCast(ScatterPolygonSeries.$, this.t5);
            if (a == null) {
                return "Unknown";
            }
            return a.ky();
        }
        pa(a, b, c, d) {
            super.pa(a, b, c, d);
            switch (b) {
                case GeographicShapeSeries.$$p[6]:
                    this.t5.w2 = this.vd;
                    break;
                case GeographicShapeSeries.$$p[5]:
                    this.t5.wy = this.vc;
                    break;
                case GeographicShapeSeries.$$p[9]:
                    this.vg.cq();
                    break;
                case GeographicShapeSeries.$$p[10]:
                    this.vg.cs();
                    break;
                case GeographicShapeSeries.$$p[4]:
                    this.vg.cn();
                    break;
                case GeographicShapeSeries.$$p[11]:
                    this.vg.cr();
                    break;
                case GeographicShapeSeries.$$p[3]:
                    this.vg.cm();
                    break;
                case GeographicShapeSeries.$$p[7]:
                    this.vg.co();
                    break;
                case GeographicShapeSeries.$$p[8]:
                    this.vg.cp();
                    break;
                case GeographicShapeSeries.$$p[13]:
                    this.vg.ct();
                    break;
                case GeographicShapeSeries.$$p[12]:
                    this.vg.cu();
                    break;
            }
        }
        ir() {
            return 0.7;
        }
    }
    GeographicShapeSeries.$t = /*@__PURE__*/ markType(GeographicShapeSeries, 'GeographicShapeSeries', GeographicShapeSeriesBase.$);
    GeographicShapeSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, GeographicShapeSeries, 'raisePropertyChanged', ['ActualMarkerBrush:wf:v1', [Brush.$], 'ActualMarkerOutline:wg:v2', [Brush.$], 'ActualMarkerTemplate:vz:v3', [DataTemplate.$, null], 'MarkerBrush:wh:v4', [Brush.$], 'MarkerCollisionAvoidance:vb:v5', [CollisionAvoidanceType_$type, /*@__PURE__*/ enumGetBox(CollisionAvoidanceType_$type, 0)], 'MarkerFillMode:vc:v6', [MarkerFillMode_$type, /*@__PURE__*/ enumGetBox(MarkerFillMode_$type, 0)], 'MarkerOutlineMode:vd:v7', [MarkerOutlineMode_$type, /*@__PURE__*/ enumGetBox(MarkerOutlineMode_$type, 0)], 'MarkerOutline:wi:v8', [Brush.$], 'MarkerStyle:wj:v9', [Style.$], 'MarkerTemplate:v0:wa', [DataTemplate.$, null], 'MarkerThickness:vh:wb', [1, /*@__PURE__*/ DeviceUtils.g(2)], 'MarkerType:ve:wc', [MarkerType_$type, /*@__PURE__*/ enumGetBox(MarkerType_$type, 2)], 'ShapeStyle:wk:wd', [Style.$, null], 'ShapeStyleSelector:vf:we', [StyleSelector.$, null]]);
    return GeographicShapeSeries;
})();
