/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { ShapeSeriesBase } from "igniteui-webcomponents-charts";
import { IMapRenderDeferralHandler_$type } from "igniteui-webcomponents-core";
import { EventArgs, runOn, delegateRemove, delegateCombine, typeCast, markType } from "igniteui-webcomponents-core";
import { XamGeographicMap } from "./XamGeographicMap";
import { ShapeSeriesViewBase } from "igniteui-webcomponents-charts";
import { RenderingContext } from "igniteui-webcomponents-core";
import { GeometryGroup } from "igniteui-webcomponents-core";
import { Defaults } from "igniteui-webcomponents-charts";
import { CanvasViewRenderer } from "igniteui-webcomponents-core";
import { truncate } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export let TileSeries = /*@__PURE__*/ (() => {
    class TileSeries extends ShapeSeriesBase {
        bc() {
            return new TileSeries();
        }
        get_fh() {
            return true;
        }
        constructor() {
            super();
            this.ww = null;
            this.wv = null;
            this.imageTilesReady = null;
            this.wz = null;
            this.w0 = false;
            this.ab = TileSeries.$;
        }
        cd() {
            return new TileSeriesView(this);
        }
        o2(a) {
            super.o2(a);
            this.wu = a;
        }
        get_u6() {
            return false;
        }
        get wy() {
            return this.ww;
        }
        set wy(a) {
            let b = a != this.wy;
            if (b) {
                let c = this.wy;
                this.ww = a;
                this.raisePropertyChanged("TileImagery", c, a);
            }
        }
        get wx() {
            return this.wv;
        }
        set wx(a) {
            let b = this.wv;
            this.wv = a;
            this.raisePropertyChanged("ActualTileImagery", b, this.wv);
        }
        pa(a, b, c, d) {
            super.pa(a, b, c, d);
            let e;
            let f;
            switch (b) {
                case "TileImagery":
                    e = c;
                    f = d;
                    if (e != null) {
                        e.propertyChanged = delegateRemove(e.propertyChanged, runOn(this, this.w3));
                    }
                    if (f != null) {
                        f.propertyChanged = delegateCombine(f.propertyChanged, runOn(this, this.w3));
                    }
                    this.wu.dh(e, f);
                    this.pr(false);
                    this.om();
                    break;
                case "ActualTileImagery":
                    e = c;
                    f = d;
                    if (e != null) {
                        e.imageTilesReady = delegateRemove(e.imageTilesReady, runOn(this, this.w4));
                        e.deferralHandler = null;
                    }
                    if (f != null) {
                        f.imageTilesReady = delegateCombine(f.imageTilesReady, runOn(this, this.w4));
                        f.deferralHandler = this;
                    }
                    this.wu.dg(e, f);
                    if (f != null && typeCast(XamGeographicMap.$, this.cv) !== null) {
                        f.geographicMap = this.cv;
                        this.w6(this.cg);
                        this.wu.dd(this.cv.tr);
                    }
                    this.om();
                    break;
                case "ActualWindowRect":
                    this.wu.dd(d);
                    break;
                case "WorldRect":
                    this.wu.dk(d);
                    break;
                case "SeriesViewer":
                    let g = c;
                    let h = d;
                    if (g != null && this.wx != null) {
                        this.wx.be(null);
                    }
                    if (h != null && this.wx != null) {
                        this.wx.be(this.cg.w);
                    }
                    break;
                case "ActualBrush":
                case "ActualOutline":
                case "ActualThickness":
                    this.oo();
                    break;
            }
        }
        w3(a, b) {
            if (b.propertyName == "MultiScaleImage") {
                this.w6(this.cg);
            }
        }
        w4(a, b) {
            if (this.imageTilesReady != null) {
                this.imageTilesReady(this, new EventArgs());
            }
            if (!this.w0) {
                this.wu.di();
            }
        }
        register(a, b) {
            this.wz = b;
        }
        unRegister(a) {
            this.wz = null;
        }
        deferredRefresh() {
            this.pr(false);
        }
        deferAction(a) {
            if (this.i5 != null) {
                this.i5.setTimeout(a, 0);
            }
            else {
                window.setTimeout(a, 0);
            }
        }
        qo(a, b) {
            this.wu.dj();
            super.qo(a, b);
        }
        ps(a) {
            super.ps(a);
            this.w5(a, this.cg);
        }
        w5(a, b) {
            let c;
            let d;
            let e = b;
            let f = b.getViewInfo(c, d);
            c = f.p0;
            d = f.p1;
            this.w6(b);
            if (this.wz != null) {
                this.w0 = true;
                this.wz(a);
                this.w0 = false;
            }
            e.di();
        }
        pq(a, b, c, d, e) {
            super.pq(a, b, c, d, e);
            let f = this.gv.item(d);
            f.a3(c);
            if (this.dm(f)) {
                return;
            }
            this.wd(f);
        }
        w6(a) {
            let b;
            let c;
            let d = a.getViewInfo(b, c);
            b = d.p0;
            c = d.p1;
            if (this.wy != null && this.wy.ao != null) {
                if (this.wy != this.wx) {
                    this.wx = this.wy;
                }
                if (this.wx != null && !b.isEmpty) {
                    if (this.wx.width != b.width) {
                        this.wx.width = b.width;
                    }
                    if (this.wx.height != b.height) {
                        this.wx.height = b.height;
                    }
                }
            }
        }
        nk(a, b) {
            super.nk(a, b);
            b.de();
        }
    }
    TileSeries.$t = /*@__PURE__*/ markType(TileSeries, 'TileSeries', ShapeSeriesBase.$, [IMapRenderDeferralHandler_$type]);
    return TileSeries;
})();
/**
 * @hidden
 */
export let TileSeriesView = /*@__PURE__*/ (() => {
    class TileSeriesView extends ShapeSeriesViewBase {
        constructor(a) {
            super(a);
            this.da = null;
            this.dl = new GeometryGroup();
            this.dc = null;
            this.db = null;
            this.da = a;
        }
        au() {
            super.au();
            if (!this.q) {
                this.da.s4 = Defaults.ao;
                this.da.sy = Defaults.an;
            }
        }
        ck(a, b) {
            if (b.c.count > 0) {
                this.dl.d.add(b);
            }
        }
        c5(a, b) {
            return this.c6(a, b, true);
        }
        c4(a, b) {
            return null;
        }
        co(a, b) {
        }
        cm(a, b, c) {
        }
        cu() {
            super.cu();
            this.dl.d.clear();
        }
        ct() {
            super.ct();
            this.as();
        }
        dd(a) {
            if (this.da.wy != null) {
                this.da.wy.windowRect = a;
            }
        }
        dg(a, b) {
            if (this.dc == null) {
                this.dc = this.e.i5.createElement("canvas");
                let c = this.e.i5.get2DCanvasContext(this.dc);
                this.db = new RenderingContext(new CanvasViewRenderer(), c);
                this.dc.setAttribute("width", this.bx.width.toString());
                this.dc.setAttribute("height", this.bx.height.toString());
            }
            if (a != null) {
                a.bd(null);
                a.be(null);
                a.imagesChanged = delegateRemove(a.imagesChanged, runOn(this, this.df));
            }
            if (b != null) {
                if (this.w != null) {
                    b.be(this.w);
                }
                b.bd(this.db);
                b.bf(this.bx);
                b.imagesChanged = delegateCombine(b.imagesChanged, runOn(this, this.df));
            }
        }
        df(a, b) {
            this.as();
        }
        dh(a, b) {
        }
        dj() {
            if (this.dc != null) {
                this.dc.setAttribute("width", this.bx.width.toString());
                this.dc.setAttribute("height", this.bx.height.toString());
            }
            if (this.da.wy != null) {
                this.da.wy.bf(this.bx);
            }
        }
        a8(a, b) {
            super.a8(a, b);
            if (b) {
                return;
            }
            if (this.dc == null) {
                return;
            }
            let c = false;
            if (this.dl.d.count > 0) {
                c = true;
                this.k.aa();
                this.k.r(this.dl);
                let d = this.k.h();
                d.clip();
            }
            let e = truncate(Math.round(this.bx.left));
            let f = truncate(Math.round(this.bx.top));
            let g = truncate(Math.round(this.bx.width));
            let h = truncate(Math.round(this.bx.height));
            this.k.o(this.dc.getNativeElement(), 1, e, f, g, h, e, f, g, h);
            if (c) {
                this.k.z();
            }
        }
        di() {
            this.as();
        }
        de() {
        }
        dk(a) {
            if (this.da.wy != null) {
                this.da.wy.a6();
            }
        }
    }
    TileSeriesView.$t = /*@__PURE__*/ markType(TileSeriesView, 'TileSeriesView', ShapeSeriesViewBase.$);
    return TileSeriesView;
})();
