import { IgcGeographicMarkerSeriesComponent } from "./igc-geographic-marker-series-component";
import { getAllPropertyNames, toSpinal } from "igniteui-webcomponents-core";
export let IgcGeographicMarkerSeriesBaseComponent = /*@__PURE__*/ (() => {
    class IgcGeographicMarkerSeriesBaseComponent extends IgcGeographicMarkerSeriesComponent {
        /**
                                     * @hidden
                                     */
        get i() {
            return this._implementation;
        }
        constructor() {
            super();
        }
        connectedCallback() {
            if (super["connectedCallback"]) {
                super["connectedCallback"]();
            }
            if (this.i.connectedCallback) {
                this.i.connectedCallback();
            }
            if (!this._attached) {
                this._attached = true;
                this._flushQueuedAttributes();
            }
        }
        disconnectedCallback() {
            if (super["disconnectedCallback"]) {
                super["disconnectedCallback"]();
            }
            if (this.i.disconnectedCallback) {
                this.i.disconnectedCallback();
            }
            if (this._attached) {
                this._attached = false;
            }
        }
        static get observedAttributes() {
            if (IgcGeographicMarkerSeriesBaseComponent._observedAttributesIgcGeographicMarkerSeriesBaseComponent == null) {
                let names = getAllPropertyNames(IgcGeographicMarkerSeriesBaseComponent);
                for (let i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcGeographicMarkerSeriesBaseComponent._observedAttributesIgcGeographicMarkerSeriesBaseComponent = names;
            }
            return IgcGeographicMarkerSeriesBaseComponent._observedAttributesIgcGeographicMarkerSeriesBaseComponent;
        }
    }
    IgcGeographicMarkerSeriesBaseComponent._observedAttributesIgcGeographicMarkerSeriesBaseComponent = null;
    return IgcGeographicMarkerSeriesBaseComponent;
})();
