import { IgcGeographicMapSeriesHostComponent } from "./igc-geographic-map-series-host-component";
import { getAllPropertyNames, toSpinal } from "igniteui-webcomponents-core";
export let IgcGeographicShapeSeriesBaseBaseComponent = /*@__PURE__*/ (() => {
    class IgcGeographicShapeSeriesBaseBaseComponent extends IgcGeographicMapSeriesHostComponent {
        /**
                                     * @hidden
                                     */
        get i() {
            return this._implementation;
        }
        constructor() {
            super();
        }
        connectedCallback() {
            if (super["connectedCallback"]) {
                super["connectedCallback"]();
            }
            if (this.i.connectedCallback) {
                this.i.connectedCallback();
            }
            if (!this._attached) {
                this._attached = true;
                this._flushQueuedAttributes();
            }
        }
        disconnectedCallback() {
            if (super["disconnectedCallback"]) {
                super["disconnectedCallback"]();
            }
            if (this.i.disconnectedCallback) {
                this.i.disconnectedCallback();
            }
            if (this._attached) {
                this._attached = false;
            }
        }
        static get observedAttributes() {
            if (IgcGeographicShapeSeriesBaseBaseComponent._observedAttributesIgcGeographicShapeSeriesBaseBaseComponent == null) {
                let names = getAllPropertyNames(IgcGeographicShapeSeriesBaseBaseComponent);
                for (let i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcGeographicShapeSeriesBaseBaseComponent._observedAttributesIgcGeographicShapeSeriesBaseBaseComponent = names;
            }
            return IgcGeographicShapeSeriesBaseBaseComponent._observedAttributesIgcGeographicShapeSeriesBaseBaseComponent;
        }
    }
    IgcGeographicShapeSeriesBaseBaseComponent._observedAttributesIgcGeographicShapeSeriesBaseBaseComponent = null;
    return IgcGeographicShapeSeriesBaseBaseComponent;
})();
