import { IgcGeographicMarkerSeriesBaseComponent } from "./igc-geographic-marker-series-base-component";
import { getAllPropertyNames, toSpinal } from "igniteui-webcomponents-core";
export let IgcGeographicSymbolSeriesBaseComponent = /*@__PURE__*/ (() => {
    class IgcGeographicSymbolSeriesBaseComponent extends IgcGeographicMarkerSeriesBaseComponent {
        /**
                                     * @hidden
                                     */
        get i() {
            return this._implementation;
        }
        constructor() {
            super();
        }
        connectedCallback() {
            if (super["connectedCallback"]) {
                super["connectedCallback"]();
            }
            if (this.i.connectedCallback) {
                this.i.connectedCallback();
            }
            if (!this._attached) {
                this._attached = true;
                this._flushQueuedAttributes();
            }
        }
        disconnectedCallback() {
            if (super["disconnectedCallback"]) {
                super["disconnectedCallback"]();
            }
            if (this.i.disconnectedCallback) {
                this.i.disconnectedCallback();
            }
            if (this._attached) {
                this._attached = false;
            }
        }
        static get observedAttributes() {
            if (IgcGeographicSymbolSeriesBaseComponent._observedAttributesIgcGeographicSymbolSeriesBaseComponent == null) {
                let names = getAllPropertyNames(IgcGeographicSymbolSeriesBaseComponent);
                for (let i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcGeographicSymbolSeriesBaseComponent._observedAttributesIgcGeographicSymbolSeriesBaseComponent = names;
            }
            return IgcGeographicSymbolSeriesBaseComponent._observedAttributesIgcGeographicSymbolSeriesBaseComponent;
        }
    }
    IgcGeographicSymbolSeriesBaseComponent._observedAttributesIgcGeographicSymbolSeriesBaseComponent = null;
    return IgcGeographicSymbolSeriesBaseComponent;
})();
