/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { GeographicShapeSeriesBaseView } from "./GeographicShapeSeriesBaseView";
import { GeographicShapeSeriesBase } from "./GeographicShapeSeriesBase";
import { Brush } from "igniteui-webcomponents-core";
import { Defaults } from "igniteui-webcomponents-charts";
import { MarkerType_$type } from "igniteui-webcomponents-charts";
import { MarkerFillMode_$type } from "igniteui-webcomponents-charts";
import { ScatterPolygonSeries } from "igniteui-webcomponents-charts";
import { markType, runOn, delegateCombine, typeCast, enumGetBox, markDep } from "igniteui-webcomponents-core";
import { StyleSelector } from "igniteui-webcomponents-charts";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { Style } from "igniteui-webcomponents-core";
import { MarkerOutlineMode_$type } from "igniteui-webcomponents-charts";
import { DataTemplate } from "igniteui-webcomponents-core";
import { CollisionAvoidanceType_$type } from "igniteui-webcomponents-charts";
import { PropertyMetadata } from "igniteui-webcomponents-core";
import { DeviceUtils } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
var GeographicShapeSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicShapeSeriesView, _super);
    function GeographicShapeSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cl = null;
        _this.cl = a;
        if (!_this.q) {
            _this.cl.uy = "points";
        }
        return _this;
    }
    GeographicShapeSeriesView.prototype.au = function () {
        _super.prototype.au.call(this);
        if (!this.q) {
            this.cl.wi = Defaults.aj;
            this.cl.iv = Defaults.p;
            this.cl.vh = Defaults.o;
            this.cl.ve = Defaults.d;
            this.cl.vc = Defaults.a;
        }
    };
    GeographicShapeSeriesView.prototype.b5 = function () {
        _super.prototype.b5.call(this);
        this.cl.t5.yg = this.cl.wk;
        this.cl.t5.w9 = this.cl.vf;
        this.cl.t5.xv = this.cl.v0;
        this.cl.t5.xc = this.cl.vh;
        this.cl.t5.wv = this.cl.vb;
    };
    GeographicShapeSeriesView.prototype.cq = function () {
        this.cl.t5.xv = this.cl.v0;
    };
    GeographicShapeSeriesView.prototype.cs = function () {
        this.cl.t5.xc = this.cl.vh;
    };
    GeographicShapeSeriesView.prototype.cn = function () {
        this.cl.t5.wv = this.cl.vb;
    };
    GeographicShapeSeriesView.prototype.cr = function () {
        this.cl.t5.w4 = this.cl.ve;
    };
    GeographicShapeSeriesView.prototype.cm = function () {
        this.cl.t5.yc = this.cl.wh;
    };
    GeographicShapeSeriesView.prototype.co = function () {
        this.cl.t5.yd = this.cl.wi;
    };
    GeographicShapeSeriesView.prototype.cp = function () {
        this.cl.t5.yf = this.cl.wj;
    };
    GeographicShapeSeriesView.prototype.ct = function () {
        this.cl.t5.w9 = this.cl.vf;
    };
    GeographicShapeSeriesView.prototype.cu = function () {
        this.cl.t5.yg = this.cl.wk;
    };
    GeographicShapeSeriesView.$t = markType(GeographicShapeSeriesView, 'GeographicShapeSeriesView', GeographicShapeSeriesBaseView.$);
    return GeographicShapeSeriesView;
}(GeographicShapeSeriesBaseView));
export { GeographicShapeSeriesView };
/**
 * @hidden
 */
var GeographicShapeSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicShapeSeries, _super);
    function GeographicShapeSeries() {
        var _this = _super.call(this) || this;
        _this.styleShape = null;
        _this.ab = GeographicShapeSeries.$;
        return _this;
    }
    GeographicShapeSeries.prototype.bc = function () {
        return new GeographicShapeSeries();
    };
    GeographicShapeSeries.prototype.get_e4 = function () {
        return true;
    };
    GeographicShapeSeries.prototype.cd = function () {
        return new GeographicShapeSeriesView(this);
    };
    GeographicShapeSeries.prototype.o2 = function (a) {
        _super.prototype.o2.call(this, a);
        this.vg = a;
    };
    GeographicShapeSeries.prototype.t4 = function () {
        var a = new ScatterPolygonSeries();
        a.styleShape = delegateCombine(a.styleShape, runOn(this, this.vx));
        a.propertyUpdated = delegateCombine(a.propertyUpdated, runOn(this, this.vy));
        return a;
    };
    GeographicShapeSeries.prototype.vx = function (a, b) {
        if (this.styleShape != null) {
            this.styleShape(this, b);
        }
    };
    GeographicShapeSeries.prototype.vy = function (a, b) {
        var c = typeCast(ScatterPolygonSeries.$, this.t5);
        if (c == null) {
            return;
        }
    };
    GeographicShapeSeries.prototype.ht = function () {
        return this.vh;
    };
    GeographicShapeSeries.prototype.s1 = function () {
        return this.wf;
    };
    GeographicShapeSeries.prototype.s2 = function () {
        return this.wg;
    };
    GeographicShapeSeries.prototype.qx = function () {
        return this.vz;
    };
    GeographicShapeSeries.prototype.ky = function () {
        var a = typeCast(ScatterPolygonSeries.$, this.t5);
        if (a == null) {
            return "Unknown";
        }
        return a.ky();
    };
    GeographicShapeSeries.prototype.pa = function (a, b, c, d) {
        _super.prototype.pa.call(this, a, b, c, d);
        switch (b) {
            case GeographicShapeSeries.$$p[6]:
                this.t5.w2 = this.vd;
                break;
            case GeographicShapeSeries.$$p[5]:
                this.t5.wy = this.vc;
                break;
            case GeographicShapeSeries.$$p[9]:
                this.vg.cq();
                break;
            case GeographicShapeSeries.$$p[10]:
                this.vg.cs();
                break;
            case GeographicShapeSeries.$$p[4]:
                this.vg.cn();
                break;
            case GeographicShapeSeries.$$p[11]:
                this.vg.cr();
                break;
            case GeographicShapeSeries.$$p[3]:
                this.vg.cm();
                break;
            case GeographicShapeSeries.$$p[7]:
                this.vg.co();
                break;
            case GeographicShapeSeries.$$p[8]:
                this.vg.cp();
                break;
            case GeographicShapeSeries.$$p[13]:
                this.vg.ct();
                break;
            case GeographicShapeSeries.$$p[12]:
                this.vg.cu();
                break;
        }
    };
    GeographicShapeSeries.prototype.ir = function () {
        return 0.7;
    };
    GeographicShapeSeries.$t = markType(GeographicShapeSeries, 'GeographicShapeSeries', GeographicShapeSeriesBase.$);
    GeographicShapeSeries.$$p = markDep(DependencyProperty, PropertyMetadata, GeographicShapeSeries, 'raisePropertyChanged', ['ActualMarkerBrush:wf:v1', [Brush.$], 'ActualMarkerOutline:wg:v2', [Brush.$], 'ActualMarkerTemplate:vz:v3', [DataTemplate.$, null], 'MarkerBrush:wh:v4', [Brush.$], 'MarkerCollisionAvoidance:vb:v5', [CollisionAvoidanceType_$type, enumGetBox(CollisionAvoidanceType_$type, 0)], 'MarkerFillMode:vc:v6', [MarkerFillMode_$type, enumGetBox(MarkerFillMode_$type, 0)], 'MarkerOutlineMode:vd:v7', [MarkerOutlineMode_$type, enumGetBox(MarkerOutlineMode_$type, 0)], 'MarkerOutline:wi:v8', [Brush.$], 'MarkerStyle:wj:v9', [Style.$], 'MarkerTemplate:v0:wa', [DataTemplate.$, null], 'MarkerThickness:vh:wb', [1, DeviceUtils.g(2)], 'MarkerType:ve:wc', [MarkerType_$type, enumGetBox(MarkerType_$type, 2)], 'ShapeStyle:wk:wd', [Style.$, null], 'ShapeStyleSelector:vf:we', [StyleSelector.$, null]]);
    return GeographicShapeSeries;
}(GeographicShapeSeriesBase));
export { GeographicShapeSeries };
