/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { HostSeriesView } from "./HostSeriesView";
import { ScatterSeries } from "igniteui-webcomponents-charts";
import { GeographicMarkerSeries } from "./GeographicMarkerSeries";
import { markType, enumGetBox, runOn, delegateCombine, delegateRemove, markDep } from "igniteui-webcomponents-core";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { CollisionAvoidanceType_$type } from "igniteui-webcomponents-charts";
import { ScatterItemSearchMode_$type } from "igniteui-webcomponents-charts";
import { PropertyMetadata } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
var GeographicSymbolSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicSymbolSeriesView, _super);
    function GeographicSymbolSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.ch = null;
        _this.ch = a;
        return _this;
    }
    GeographicSymbolSeriesView.prototype.au = function () {
        _super.prototype.au.call(this);
        if (!this.q) {
        }
    };
    GeographicSymbolSeriesView.prototype.b5 = function () {
        var a = this.ch.t5;
        _super.prototype.b5.call(this);
        a.xn = this.ch.vt;
        a.xv = this.ch.vr;
        a.uc = this.ch.uf;
        a.uy = this.ch.uv;
        a.uh = this.ch.ug;
    };
    GeographicSymbolSeriesView.prototype.cj = function () {
        this.ch.t5.xn = this.ch.vt;
    };
    GeographicSymbolSeriesView.prototype.ci = function () {
        this.ch.t5.xv = this.ch.vr;
    };
    GeographicSymbolSeriesView.prototype.cp = function () {
        this.ch.t5.uc = this.ch.uf;
    };
    GeographicSymbolSeriesView.prototype.cn = function () {
        this.ch.t5.uy = this.ch.uv;
    };
    GeographicSymbolSeriesView.prototype.co = function () {
        this.ch.t5.uh = this.ch.ug;
    };
    GeographicSymbolSeriesView.prototype.cq = function () {
        this.ch.t5.w3 = this.ch.uh;
    };
    GeographicSymbolSeriesView.prototype.cs = function () {
        this.ch.t5.xAxis = this.ch.cv.ue;
    };
    GeographicSymbolSeriesView.prototype.ct = function () {
        this.ch.t5.yAxis = this.ch.cv.ug;
    };
    GeographicSymbolSeriesView.prototype.cr = function () {
        var a = this.ch.t5;
        if (this.ch.cv == null) {
            a.xAxis = null;
            a.yAxis = null;
            return;
        }
        a.xAxis = this.ch.cv.ue;
        a.yAxis = this.ch.cv.ug;
    };
    GeographicSymbolSeriesView.prototype.cl = function () {
        this.ch.t5.vo = this.ch.vd;
    };
    GeographicSymbolSeriesView.prototype.ck = function () {
        this.ch.t5.ve = this.ch.u9;
    };
    GeographicSymbolSeriesView.prototype.cm = function () {
        this.ch.t5.vf = this.ch.va;
    };
    GeographicSymbolSeriesView.$t = markType(GeographicSymbolSeriesView, 'GeographicSymbolSeriesView', HostSeriesView.$);
    return GeographicSymbolSeriesView;
}(HostSeriesView));
export { GeographicSymbolSeriesView };
/**
 * @hidden
 */
var GeographicSymbolSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicSymbolSeries, _super);
    function GeographicSymbolSeries() {
        var _this = _super.call(this) || this;
        _this.vf = null;
        _this.vi = false;
        _this.vh = false;
        _this.assigningScatterStyle = null;
        _this.assigningScatterMarkerStyle = null;
        _this.ab = GeographicSymbolSeries.$;
        return _this;
    }
    GeographicSymbolSeries.prototype.bc = function () {
        return new GeographicSymbolSeries();
    };
    GeographicSymbolSeries.prototype.get_dy = function () {
        return true;
    };
    GeographicSymbolSeries.prototype.cd = function () {
        return new GeographicSymbolSeriesView(this);
    };
    GeographicSymbolSeries.prototype.o2 = function (a) {
        _super.prototype.o2.call(this, a);
        this.vg = a;
    };
    GeographicSymbolSeries.prototype.ir = function () {
        return 0.7;
    };
    GeographicSymbolSeries.prototype.t4 = function () {
        return new ScatterSeries();
    };
    GeographicSymbolSeries.prototype.get_et = function () {
        return true;
    };
    GeographicSymbolSeries.prototype.pa = function (a, b, c, d) {
        _super.prototype.pa.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                this.vg.cr();
                break;
            case GeographicSymbolSeries.$$p[5]:
                this.vg.cj();
                break;
            case GeographicSymbolSeries.$$p[4]:
                this.vg.ci();
                break;
            case GeographicSymbolSeries.$$p[6]:
                this.vg.cl();
                break;
            case "XAxis":
                this.vg.cs();
                break;
            case "YAxis":
                this.vg.ct();
                break;
            case GeographicSymbolSeries.$$p[1]:
                this.t5.wk = this.vk;
                this.vi = this.vk;
                if (this.vk) {
                    var e = this.t5;
                    e.assigningScatterStyle = delegateCombine(e.assigningScatterStyle, runOn(this, this.vy));
                }
                else {
                    var f = this.t5;
                    f.assigningScatterStyle = delegateRemove(f.assigningScatterStyle, runOn(this, this.vy));
                }
                break;
            case GeographicSymbolSeries.$$p[0]:
                this.t5.wj = this.vj;
                this.vh = this.vj;
                if (this.vk) {
                    var g = this.t5;
                    g.assigningScatterMarkerStyle = delegateCombine(g.assigningScatterMarkerStyle, runOn(this, this.vx));
                }
                else {
                    var h = this.t5;
                    h.assigningScatterMarkerStyle = delegateRemove(h.assigningScatterMarkerStyle, runOn(this, this.vx));
                }
                break;
            case GeographicSymbolSeries.$$p[2]:
                this.t5.v3 = this.ve;
                break;
            case GeographicSymbolSeries.$$p[3]:
                this.t5.w2 = this.vm;
                break;
        }
    };
    GeographicSymbolSeries.prototype.vy = function (a, b) {
        if (this.assigningScatterStyle != null) {
            this.assigningScatterStyle(this, b);
        }
    };
    GeographicSymbolSeries.prototype.vx = function (a, b) {
        if (this.assigningScatterMarkerStyle != null) {
            this.assigningScatterMarkerStyle(this, b);
        }
    };
    GeographicSymbolSeries.$t = markType(GeographicSymbolSeries, 'GeographicSymbolSeries', GeographicMarkerSeries.$);
    GeographicSymbolSeries.$$p = markDep(DependencyProperty, PropertyMetadata, GeographicSymbolSeries, 'raisePropertyChanged', ['IsCustomScatterMarkerStyleAllowed:vj:vz', [0, false], 'IsCustomScatterStyleAllowed:vk:v0', [0, false], 'ItemSearchMode:ve:v1', [ScatterItemSearchMode_$type, enumGetBox(ScatterItemSearchMode_$type, 0)], 'ItemSearchThreshold:vm:v2', [1, 10000], 'LatitudeMemberPath:vr:v3', [2, null], 'LongitudeMemberPath:vt:v4', [2, null], 'MarkerCollisionAvoidance:vd:v5', [CollisionAvoidanceType_$type, enumGetBox(CollisionAvoidanceType_$type, 0)], 'UseLightweightMarkers:vl:v6', [0, false]]);
    return GeographicSymbolSeries;
}(GeographicMarkerSeries));
export { GeographicSymbolSeries };
