/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { ShapeSeriesBase } from "igniteui-webcomponents-charts";
import { IMapRenderDeferralHandler_$type } from "igniteui-webcomponents-core";
import { EventArgs, runOn, delegateRemove, delegateCombine, typeCast, markType } from "igniteui-webcomponents-core";
import { XamGeographicMap } from "./XamGeographicMap";
import { ShapeSeriesViewBase } from "igniteui-webcomponents-charts";
import { RenderingContext } from "igniteui-webcomponents-core";
import { GeometryGroup } from "igniteui-webcomponents-core";
import { Defaults } from "igniteui-webcomponents-charts";
import { CanvasViewRenderer } from "igniteui-webcomponents-core";
import { truncate } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
var TileSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TileSeries, _super);
    function TileSeries() {
        var _this = _super.call(this) || this;
        _this.ww = null;
        _this.wv = null;
        _this.imageTilesReady = null;
        _this.wz = null;
        _this.w0 = false;
        _this.ab = TileSeries.$;
        return _this;
    }
    TileSeries.prototype.bc = function () {
        return new TileSeries();
    };
    TileSeries.prototype.get_fh = function () {
        return true;
    };
    TileSeries.prototype.cd = function () {
        return new TileSeriesView(this);
    };
    TileSeries.prototype.o2 = function (a) {
        _super.prototype.o2.call(this, a);
        this.wu = a;
    };
    TileSeries.prototype.get_u6 = function () {
        return false;
    };
    Object.defineProperty(TileSeries.prototype, "wy", {
        get: function () {
            return this.ww;
        },
        set: function (a) {
            var b = a != this.wy;
            if (b) {
                var c = this.wy;
                this.ww = a;
                this.raisePropertyChanged("TileImagery", c, a);
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(TileSeries.prototype, "wx", {
        get: function () {
            return this.wv;
        },
        set: function (a) {
            var b = this.wv;
            this.wv = a;
            this.raisePropertyChanged("ActualTileImagery", b, this.wv);
        },
        enumerable: false,
        configurable: true
    });
    TileSeries.prototype.pa = function (a, b, c, d) {
        _super.prototype.pa.call(this, a, b, c, d);
        var e;
        var f;
        switch (b) {
            case "TileImagery":
                e = c;
                f = d;
                if (e != null) {
                    e.propertyChanged = delegateRemove(e.propertyChanged, runOn(this, this.w3));
                }
                if (f != null) {
                    f.propertyChanged = delegateCombine(f.propertyChanged, runOn(this, this.w3));
                }
                this.wu.dh(e, f);
                this.pr(false);
                this.om();
                break;
            case "ActualTileImagery":
                e = c;
                f = d;
                if (e != null) {
                    e.imageTilesReady = delegateRemove(e.imageTilesReady, runOn(this, this.w4));
                    e.deferralHandler = null;
                }
                if (f != null) {
                    f.imageTilesReady = delegateCombine(f.imageTilesReady, runOn(this, this.w4));
                    f.deferralHandler = this;
                }
                this.wu.dg(e, f);
                if (f != null && typeCast(XamGeographicMap.$, this.cv) !== null) {
                    f.geographicMap = this.cv;
                    this.w6(this.cg);
                    this.wu.dd(this.cv.tr);
                }
                this.om();
                break;
            case "ActualWindowRect":
                this.wu.dd(d);
                break;
            case "WorldRect":
                this.wu.dk(d);
                break;
            case "SeriesViewer":
                var g = c;
                var h = d;
                if (g != null && this.wx != null) {
                    this.wx.be(null);
                }
                if (h != null && this.wx != null) {
                    this.wx.be(this.cg.w);
                }
                break;
            case "ActualBrush":
            case "ActualOutline":
            case "ActualThickness":
                this.oo();
                break;
        }
    };
    TileSeries.prototype.w3 = function (a, b) {
        if (b.propertyName == "MultiScaleImage") {
            this.w6(this.cg);
        }
    };
    TileSeries.prototype.w4 = function (a, b) {
        if (this.imageTilesReady != null) {
            this.imageTilesReady(this, new EventArgs());
        }
        if (!this.w0) {
            this.wu.di();
        }
    };
    TileSeries.prototype.register = function (a, b) {
        this.wz = b;
    };
    TileSeries.prototype.unRegister = function (a) {
        this.wz = null;
    };
    TileSeries.prototype.deferredRefresh = function () {
        this.pr(false);
    };
    TileSeries.prototype.deferAction = function (a) {
        if (this.i5 != null) {
            this.i5.setTimeout(a, 0);
        }
        else {
            window.setTimeout(a, 0);
        }
    };
    TileSeries.prototype.qo = function (a, b) {
        this.wu.dj();
        _super.prototype.qo.call(this, a, b);
    };
    TileSeries.prototype.ps = function (a) {
        _super.prototype.ps.call(this, a);
        this.w5(a, this.cg);
    };
    TileSeries.prototype.w5 = function (a, b) {
        var c;
        var d;
        var e = b;
        var f = b.getViewInfo(c, d);
        c = f.p0;
        d = f.p1;
        this.w6(b);
        if (this.wz != null) {
            this.w0 = true;
            this.wz(a);
            this.w0 = false;
        }
        e.di();
    };
    TileSeries.prototype.pq = function (a, b, c, d, e) {
        _super.prototype.pq.call(this, a, b, c, d, e);
        var f = this.gv.item(d);
        f.a3(c);
        if (this.dm(f)) {
            return;
        }
        this.wd(f);
    };
    TileSeries.prototype.w6 = function (a) {
        var b;
        var c;
        var d = a.getViewInfo(b, c);
        b = d.p0;
        c = d.p1;
        if (this.wy != null && this.wy.ao != null) {
            if (this.wy != this.wx) {
                this.wx = this.wy;
            }
            if (this.wx != null && !b.isEmpty) {
                if (this.wx.width != b.width) {
                    this.wx.width = b.width;
                }
                if (this.wx.height != b.height) {
                    this.wx.height = b.height;
                }
            }
        }
    };
    TileSeries.prototype.nk = function (a, b) {
        _super.prototype.nk.call(this, a, b);
        b.de();
    };
    TileSeries.$t = markType(TileSeries, 'TileSeries', ShapeSeriesBase.$, [IMapRenderDeferralHandler_$type]);
    return TileSeries;
}(ShapeSeriesBase));
export { TileSeries };
/**
 * @hidden
 */
var TileSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(TileSeriesView, _super);
    function TileSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.da = null;
        _this.dl = new GeometryGroup();
        _this.dc = null;
        _this.db = null;
        _this.da = a;
        return _this;
    }
    TileSeriesView.prototype.au = function () {
        _super.prototype.au.call(this);
        if (!this.q) {
            this.da.s4 = Defaults.ao;
            this.da.sy = Defaults.an;
        }
    };
    TileSeriesView.prototype.ck = function (a, b) {
        if (b.c.count > 0) {
            this.dl.d.add(b);
        }
    };
    TileSeriesView.prototype.c5 = function (a, b) {
        return this.c6(a, b, true);
    };
    TileSeriesView.prototype.c4 = function (a, b) {
        return null;
    };
    TileSeriesView.prototype.co = function (a, b) {
    };
    TileSeriesView.prototype.cm = function (a, b, c) {
    };
    TileSeriesView.prototype.cu = function () {
        _super.prototype.cu.call(this);
        this.dl.d.clear();
    };
    TileSeriesView.prototype.ct = function () {
        _super.prototype.ct.call(this);
        this.as();
    };
    TileSeriesView.prototype.dd = function (a) {
        if (this.da.wy != null) {
            this.da.wy.windowRect = a;
        }
    };
    TileSeriesView.prototype.dg = function (a, b) {
        if (this.dc == null) {
            this.dc = this.e.i5.createElement("canvas");
            var c = this.e.i5.get2DCanvasContext(this.dc);
            this.db = new RenderingContext(new CanvasViewRenderer(), c);
            this.dc.setAttribute("width", this.bx.width.toString());
            this.dc.setAttribute("height", this.bx.height.toString());
        }
        if (a != null) {
            a.bd(null);
            a.be(null);
            a.imagesChanged = delegateRemove(a.imagesChanged, runOn(this, this.df));
        }
        if (b != null) {
            if (this.w != null) {
                b.be(this.w);
            }
            b.bd(this.db);
            b.bf(this.bx);
            b.imagesChanged = delegateCombine(b.imagesChanged, runOn(this, this.df));
        }
    };
    TileSeriesView.prototype.df = function (a, b) {
        this.as();
    };
    TileSeriesView.prototype.dh = function (a, b) {
    };
    TileSeriesView.prototype.dj = function () {
        if (this.dc != null) {
            this.dc.setAttribute("width", this.bx.width.toString());
            this.dc.setAttribute("height", this.bx.height.toString());
        }
        if (this.da.wy != null) {
            this.da.wy.bf(this.bx);
        }
    };
    TileSeriesView.prototype.a8 = function (a, b) {
        _super.prototype.a8.call(this, a, b);
        if (b) {
            return;
        }
        if (this.dc == null) {
            return;
        }
        var c = false;
        if (this.dl.d.count > 0) {
            c = true;
            this.k.aa();
            this.k.r(this.dl);
            var d = this.k.h();
            d.clip();
        }
        var e = truncate(Math.round(this.bx.left));
        var f = truncate(Math.round(this.bx.top));
        var g = truncate(Math.round(this.bx.width));
        var h = truncate(Math.round(this.bx.height));
        this.k.o(this.dc.getNativeElement(), 1, e, f, g, h, e, f, g, h);
        if (c) {
            this.k.z();
        }
    };
    TileSeriesView.prototype.di = function () {
        this.as();
    };
    TileSeriesView.prototype.de = function () {
    };
    TileSeriesView.prototype.dk = function (a) {
        if (this.da.wy != null) {
            this.da.wy.a6();
        }
    };
    TileSeriesView.$t = markType(TileSeriesView, 'TileSeriesView', ShapeSeriesViewBase.$);
    return TileSeriesView;
}(ShapeSeriesViewBase));
export { TileSeriesView };
