/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE: you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { IgcGeographicShapeSeriesModule } from './igc-geographic-shape-series-module';
import { IgcGeographicPolylineSeriesModule } from './igc-geographic-polyline-series-module';
import { IgcTileGeneratorMapImageryModule } from './igc-tile-generator-map-imagery-module';
import { IgcHeatTileGeneratorModule } from "igniteui-webcomponents-core";
import { IgcGeographicTileSeriesModule } from './igc-geographic-tile-series-module';
import { IgcSizeScaleModule } from "igniteui-webcomponents-charts";
import { IgcValueBrushScaleModule } from "igniteui-webcomponents-charts";
import { IgcCustomPaletteColorScaleModule } from "igniteui-webcomponents-charts";
import { IgcGeographicProportionalSymbolSeriesModule } from './igc-geographic-proportional-symbol-series-module';
import { IgcGeographicSymbolSeriesModule } from './igc-geographic-symbol-series-module';
import { IgcGeographicScatterAreaSeriesModule } from './igc-geographic-scatter-area-series-module';
import { IgcGeographicHighDensityScatterSeriesModule } from './igc-geographic-high-density-scatter-series-module';
import { IgcGeographicContourLineSeriesModule } from './igc-geographic-contour-line-series-module';
import { IgcGeographicMapCoreModule } from './igc-geographic-map-core-module';
import { IgcShapeDataSourceModule } from "igniteui-webcomponents-core";
var IgcGeographicMapModule = /** @class */ /*@__PURE__*/ (function () {
    function IgcGeographicMapModule() {
    }
    IgcGeographicMapModule.register = function () {
        IgcGeographicShapeSeriesModule.register();
        IgcGeographicPolylineSeriesModule.register();
        IgcTileGeneratorMapImageryModule.register();
        IgcHeatTileGeneratorModule.register();
        IgcGeographicTileSeriesModule.register();
        IgcSizeScaleModule.register();
        IgcValueBrushScaleModule.register();
        IgcCustomPaletteColorScaleModule.register();
        IgcGeographicProportionalSymbolSeriesModule.register();
        IgcGeographicSymbolSeriesModule.register();
        IgcGeographicScatterAreaSeriesModule.register();
        IgcGeographicHighDensityScatterSeriesModule.register();
        IgcGeographicContourLineSeriesModule.register();
        IgcGeographicMapCoreModule.register();
        IgcShapeDataSourceModule.register();
    };
    return IgcGeographicMapModule;
}());
export { IgcGeographicMapModule };
