import { GeographicMapImagery } from "./GeographicMapImagery";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { Type } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export declare class ArcGISOnlineMapImagery extends GeographicMapImagery {
    static $t: Type;
    private static readonly bv;
    constructor();
    static readonly mapServerUriProperty: DependencyProperty;
    get mapServerUri(): string;
    set mapServerUri(a: string);
    private static cd;
    static readonly userNameProperty: DependencyProperty;
    get userName(): string;
    set userName(a: string);
    private static cg;
    static readonly passwordProperty: DependencyProperty;
    get password(): string;
    set password(a: string);
    private static ce;
    static readonly userTokenProperty: DependencyProperty;
    get userToken(): string;
    set userToken(a: string);
    private static ch;
    static readonly isMapPublicProperty: DependencyProperty;
    get isMapPublic(): boolean;
    set isMapPublic(a: boolean);
    private static cc;
    private bp;
    get defaultTokenTimeout(): number;
    set defaultTokenTimeout(a: number);
    private bu;
    get tokenGenerationEndPoint(): string;
    set tokenGenerationEndPoint(a: string);
    private bt;
    get refererUri(): string;
    set refererUri(a: string);
    acquireNewToken(): void;
    private b9;
    private b8;
    private ci;
    private _pendingTokenRequest_;
    private _pendingMapServerRequest_;
    private getResponseCompleted_TokenResponse;
    private getResponseCompleted_MapServerResponse;
    private cf;
}
