import { GeographicMapImageryView } from "./GeographicMapImageryView";
import { SubDomainsCollection } from "./SubDomainsCollection";
import { GeographicMapImagery } from "./GeographicMapImagery";
import { Type } from "igniteui-webcomponents-core";
import { BingMapsImageryStyle } from "./BingMapsImageryStyle";
/**
 * @hidden
 */
export declare class BingMapsMapImageryView extends GeographicMapImageryView {
    static $t: Type;
    constructor(a: BingMapsMapImagery);
    protected k: BingMapsMapImagery;
    m(): void;
    o(): void;
    l(): void;
    n(): void;
}
/**
 * @hidden
 */
export declare class BingMapsMapImagery extends GeographicMapImagery {
    static $t: Type;
    private _pendingBingRequest_;
    private static readonly cc;
    constructor();
    protected ai(): GeographicMapImageryView;
    protected bb(a: GeographicMapImageryView): void;
    bp: BingMapsMapImageryView;
    private _isInitialized;
    get isInitialized(): boolean;
    set isInitialized(a: boolean);
    isDeferredLoad: boolean;
    tilePath: string;
    private bz;
    get actualTilePath(): string;
    set actualTilePath(a: string);
    subDomains: SubDomainsCollection;
    private bq;
    get actualSubDomains(): SubDomainsCollection;
    set actualSubDomains(a: SubDomainsCollection);
    private b0;
    get bingImageryRestUri(): string;
    set bingImageryRestUri(a: string);
    private by;
    get actualBingImageryRestUri(): string;
    set actualBingImageryRestUri(a: string);
    cultureName: string;
    apiKey: string;
    imageryStyle: BingMapsImageryStyle;
    requestMapSettings(): void;
    private co;
    private bw;
    private cq;
    private bv;
    private cj;
    private cp;
    private cl;
    private getResponseCompleted;
    private ci;
    private cm;
    static $$p: string[];
}
