import { HostSeriesView } from "./HostSeriesView";
import { SeriesView } from "igniteui-webcomponents-charts";
import { GeographicMarkerSeries } from "./GeographicMarkerSeries";
import { Series } from "igniteui-webcomponents-charts";
import { Type } from "igniteui-webcomponents-core";
import { SizeScale } from "igniteui-webcomponents-charts";
import { BrushScale } from "igniteui-webcomponents-charts";
import { ScatterItemSearchMode } from "igniteui-webcomponents-charts";
import { AssigningScatterStyleEventArgs } from "igniteui-webcomponents-charts";
import { AssigningScatterMarkerStyleEventArgs } from "igniteui-webcomponents-charts";
/**
 * @hidden
 */
export declare class GeographicProportionalSymbolSeriesView extends HostSeriesView {
    static $t: Type;
    constructor(a: GeographicProportionalSymbolSeries);
    private ch;
    au(): void;
    b5(): void;
    cq(): void;
    cp(): void;
    cv(): void;
    ct(): void;
    cu(): void;
    cw(): void;
    cy(): void;
    cz(): void;
    cx(): void;
    cr(): void;
    cs(): void;
    c0(): void;
    c1(): void;
    cl(): void;
    cj(): void;
    ci(): void;
    c2(): void;
    ck(): void;
    co(): void;
    cn(): void;
    cm(): void;
}
/**
 * @hidden
 */
export declare class GeographicProportionalSymbolSeries extends GeographicMarkerSeries {
    static $t: Type;
    protected bc(): Series;
    protected get_dy(): boolean;
    constructor();
    protected cd(): SeriesView;
    o2(a: SeriesView): void;
    vh: GeographicProportionalSymbolSeriesView;
    protected ir(): number;
    protected t4(): Series;
    private ve;
    v2: string;
    v4: string;
    v9: string;
    vg: SizeScale;
    v0: string;
    vs: string;
    vd: BrushScale;
    vk: boolean;
    vn: boolean;
    vq: number;
    vp: number;
    vo: boolean;
    vm: boolean;
    vl: boolean;
    protected vj: boolean;
    protected vi: boolean;
    protected get_et(): boolean;
    assigningScatterStyle: (sender: any, args: AssigningScatterStyleEventArgs) => void;
    assigningScatterMarkerStyle: (sender: any, args: AssigningScatterMarkerStyleEventArgs) => void;
    vf: ScatterItemSearchMode;
    vr: number;
    protected pa(a: any, b: string, c: any, d: any): void;
    private we;
    private wd;
    static $$p: string[];
}
