import { HostSeriesView } from "./HostSeriesView";
import { SeriesView } from "igniteui-webcomponents-charts";
import { GeographicMarkerSeries } from "./GeographicMarkerSeries";
import { Series } from "igniteui-webcomponents-charts";
import { Type } from "igniteui-webcomponents-core";
import { CollisionAvoidanceType } from "igniteui-webcomponents-charts";
import { ScatterItemSearchMode } from "igniteui-webcomponents-charts";
import { AssigningScatterStyleEventArgs } from "igniteui-webcomponents-charts";
import { AssigningScatterMarkerStyleEventArgs } from "igniteui-webcomponents-charts";
/**
 * @hidden
 */
export declare class GeographicSymbolSeriesView extends HostSeriesView {
    static $t: Type;
    constructor(a: GeographicSymbolSeries);
    private ch;
    au(): void;
    b5(): void;
    cj(): void;
    ci(): void;
    cp(): void;
    cn(): void;
    co(): void;
    cq(): void;
    cs(): void;
    ct(): void;
    cr(): void;
    cl(): void;
    ck(): void;
    cm(): void;
}
/**
 * @hidden
 */
export declare class GeographicSymbolSeries extends GeographicMarkerSeries {
    static $t: Type;
    protected bc(): Series;
    protected get_dy(): boolean;
    constructor();
    protected cd(): SeriesView;
    o2(a: SeriesView): void;
    vg: GeographicSymbolSeriesView;
    protected ir(): number;
    protected t4(): Series;
    private vf;
    vr: string;
    vt: string;
    vd: CollisionAvoidanceType;
    vk: boolean;
    vj: boolean;
    protected vi: boolean;
    protected vh: boolean;
    protected get_et(): boolean;
    assigningScatterStyle: (sender: any, args: AssigningScatterStyleEventArgs) => void;
    assigningScatterMarkerStyle: (sender: any, args: AssigningScatterMarkerStyleEventArgs) => void;
    ve: ScatterItemSearchMode;
    vm: number;
    protected pa(a: any, b: string, c: any, d: any): void;
    private vy;
    private vx;
    vl: boolean;
    static $$p: string[];
}
