import { ShapeSeriesBase } from "igniteui-webcomponents-charts";
import { IMapRenderDeferralHandler } from "igniteui-webcomponents-core";
import { GeographicMapImagery } from "./GeographicMapImagery";
import { Type, EventArgs } from "igniteui-webcomponents-core";
import { Series } from "igniteui-webcomponents-charts";
import { SeriesView } from "igniteui-webcomponents-charts";
import { Rect } from "igniteui-webcomponents-core";
import { DependencyObject } from "igniteui-webcomponents-core";
import { RenderSurface } from "igniteui-webcomponents-charts";
import { FrameworkElement } from "igniteui-webcomponents-core";
import { ShapeSeriesViewBase } from "igniteui-webcomponents-charts";
import { RenderingContext } from "igniteui-webcomponents-core";
import { PathGeometry } from "igniteui-webcomponents-core";
import { List$1 } from "igniteui-webcomponents-core";
import { PointCollection } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export declare class TileSeries extends ShapeSeriesBase implements IMapRenderDeferralHandler {
    static $t: Type;
    protected bc(): Series;
    protected get_fh(): boolean;
    constructor();
    protected cd(): SeriesView;
    o2(a: SeriesView): void;
    protected get_u6(): boolean;
    protected wu: TileSeriesView;
    get wy(): GeographicMapImagery;
    set wy(a: GeographicMapImagery);
    private ww;
    private wv;
    protected get wx(): GeographicMapImagery;
    protected set wx(a: GeographicMapImagery);
    protected pa(a: any, b: string, c: any, d: any): void;
    private w3;
    imageTilesReady: (sender: any, e: EventArgs) => void;
    private w4;
    private wz;
    register(a: DependencyObject, b: (arg1: boolean) => void): void;
    unRegister(a: DependencyObject): void;
    deferredRefresh(): void;
    deferAction(a: () => void): void;
    protected qo(a: Rect, b: Rect): void;
    private w0;
    ps(a: boolean): void;
    protected w5(a: boolean, b: SeriesView): void;
    pq(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    private w6;
    nk(a: boolean, b: SeriesView): void;
}
/**
 * @hidden
 */
export declare class TileSeriesView extends ShapeSeriesViewBase {
    static $t: Type;
    constructor(a: TileSeries);
    protected da: TileSeries;
    au(): void;
    protected ck(a: FrameworkElement, b: PathGeometry): void;
    protected c5(a: number, b: List$1<PointCollection>): PathGeometry;
    protected c4(a: number, b: any): FrameworkElement;
    protected co(a: FrameworkElement, b: boolean): void;
    cm(a: FrameworkElement, b: any, c: boolean): void;
    private dl;
    cu(): void;
    ct(): void;
    dd(a: Rect): void;
    private dc;
    private db;
    dg(a: GeographicMapImagery, b: GeographicMapImagery): void;
    private df;
    dh(a: GeographicMapImagery, b: GeographicMapImagery): void;
    dj(): void;
    protected a8(a: RenderingContext, b: boolean): void;
    di(): void;
    de(): void;
    dk(a: Rect): void;
}
