import { IgcGetTileImageUriArgs } from "igniteui-webcomponents-core";
import { IgcGeographicMapImagery } from "./igc-geographic-map-imagery";
import { CustomMapImagery as CustomMapImagery_internal } from "./CustomMapImagery";
/**
 * Represents a CustomMapImagery MapImagery
*/
export declare class IgcCustomMapImagery extends IgcGeographicMapImagery {
    /**
                                 * @hidden
                                 */
    get i(): CustomMapImagery_internal;
    constructor();
    private _getTileImageUri;
    private _getTileImageUri_wrapped;
    /**
     * Raised when URI for tiles should be provided
    */
    get getTileImageUri(): (s: IgcCustomMapImagery, e: IgcGetTileImageUriArgs) => void;
    set getTileImageUri(ev: (s: IgcCustomMapImagery, e: IgcGetTileImageUriArgs) => void);
}
