/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { GeographicMapImagery } from "./GeographicMapImagery";
import { runOn, delegateCombine, markType } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export let CustomMapImagery = /*@__PURE__*/ (() => {
    class CustomMapImagery extends GeographicMapImagery {
        constructor(a) {
            super(a);
            this.getTileImageUri = null;
            a.getTileImageUri = delegateCombine(a.getTileImageUri, runOn(this, this.bq));
        }
        bq(a, b) {
            this.bp(b);
        }
        bp(a) {
            if (this.getTileImageUri != null) {
                this.getTileImageUri(this, a);
            }
        }
    }
    CustomMapImagery.$t = /*@__PURE__*/ markType(CustomMapImagery, 'CustomMapImagery', GeographicMapImagery.$);
    return CustomMapImagery;
})();
