/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { HostSeriesView } from "./HostSeriesView";
import { HighDensityScatterSeries } from "igniteui-webcomponents-charts";
import { GeographicMapSeriesHost } from "./GeographicMapSeriesHost";
import { Color } from "igniteui-webcomponents-core";
import { Defaults } from "igniteui-webcomponents-charts";
import { typeCast, markType, runOn, delegateCombine, markDep } from "igniteui-webcomponents-core";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { PropertyMetadata } from "igniteui-webcomponents-core";
import { isNaN_ } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export let GeographicHighDensityScatterSeriesView = /*@__PURE__*/ (() => {
    class GeographicHighDensityScatterSeriesView extends HostSeriesView {
        constructor(a) {
            super(a);
            this.ch = null;
            this.ch = a;
        }
        b5() {
            super.b5();
            let a = typeCast(HighDensityScatterSeries.$, this.ch.t5);
            a.wd = this.ch.uu;
            a.wl = this.ch.us;
            a.uq = this.ch.uh;
            a.up = this.ch.ug;
            a.fl = this.ch.uf;
            a.vl = this.ch.uj;
            a.vk = this.ch.ui;
            a.xj = this.ch.vd;
            a.xi = this.ch.vc;
            a.vx = this.ch.um;
        }
        cn() {
            this.ch.t5.wd = this.ch.uu;
        }
        cm() {
            this.ch.t5.wl = this.ch.us;
        }
        cs() {
            this.ch.t5.uq = this.ch.uh;
        }
        cq() {
            this.ch.t5.up = this.ch.ug;
        }
        co() {
            this.ch.t5.fl = this.ch.uf;
        }
        cl() {
            this.ch.t5.vl = this.ch.uj;
        }
        cj() {
            this.ch.t5.vk = this.ch.ui;
        }
        cr() {
            let a = typeCast(HighDensityScatterSeries.$, this.ch.t5);
            if (this.ch.cv == null) {
                a.ua = null;
                a.uc = null;
                return;
            }
            a.ua = this.ch.cv.ue;
            a.uc = this.ch.cv.ug;
        }
        ct() {
            this.ch.t5.ua = this.ch.cv.ue;
        }
        cu() {
            this.ch.t5.uc = this.ch.cv.ug;
        }
        ck() {
            this.ch.t5.xj = this.ch.vd;
        }
        ci() {
            this.ch.t5.xi = this.ch.vc;
        }
        cp() {
            this.ch.t5.vx = this.ch.um;
        }
        au() {
            super.au();
            if (!this.q) {
                this.ch.vd = Defaults.aq;
                this.ch.vc = Defaults.ap;
                this.ch.sy = Defaults.al;
                this.ch.s4 = Defaults.ak;
            }
        }
    }
    GeographicHighDensityScatterSeriesView.$t = /*@__PURE__*/ markType(GeographicHighDensityScatterSeriesView, 'GeographicHighDensityScatterSeriesView', HostSeriesView.$);
    return GeographicHighDensityScatterSeriesView;
})();
/**
 * @hidden
 */
export let GeographicHighDensityScatterSeries = /*@__PURE__*/ (() => {
    class GeographicHighDensityScatterSeries extends GeographicMapSeriesHost {
        bc() {
            return new GeographicHighDensityScatterSeries();
        }
        iq() {
            if (!isNaN_(this.ip)) {
                return super.iq();
            }
            return Defaults.q;
        }
        get_e2() {
            return true;
        }
        constructor() {
            super();
            this.ud = null;
            this.progressiveLoadStatusChanged = null;
            this.ul = 0;
            this.ab = GeographicHighDensityScatterSeries.$;
        }
        cd() {
            return new GeographicHighDensityScatterSeriesView(this);
        }
        o2(a) {
            super.o2(a);
            this.ue = a;
        }
        t4() {
            this.ud = new HighDensityScatterSeries();
            return this.ud;
        }
        get un() {
            return this.ul;
        }
        set un(a) {
            let b = this.ul;
            this.ul = a;
            this.raisePropertyChanged("ProgressiveStatus", b, this.ul);
        }
        ua() {
            super.ua();
            let a = this.t5;
            a.progressiveLoadStatusChanged = delegateCombine(a.progressiveLoadStatusChanged, runOn(this, this.u1));
            let b = this.t5;
            b.propertyUpdated = delegateCombine(b.propertyUpdated, runOn(this, this.u0));
        }
        u1(a, b) {
            this.un = b.currentStatus;
            if (this.progressiveLoadStatusChanged != null) {
                this.progressiveLoadStatusChanged(this, b);
            }
        }
        u0(a, b) {
            if (this.ud == null) {
                return;
            }
        }
        pa(a, b, c, d) {
            super.pa(a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    this.ue.cr();
                    break;
                case GeographicHighDensityScatterSeries.$$p[5]:
                    this.ue.cn();
                    break;
                case GeographicHighDensityScatterSeries.$$p[4]:
                    this.ue.cm();
                    break;
                case GeographicHighDensityScatterSeries.$$p[9]:
                    this.ue.cs();
                    break;
                case GeographicHighDensityScatterSeries.$$p[8]:
                    this.ue.cq();
                    break;
                case GeographicHighDensityScatterSeries.$$p[6]:
                    this.ue.co();
                    break;
                case "XAxis":
                    this.ue.ct();
                    break;
                case "YAxis":
                    this.ue.cu();
                    break;
                case GeographicHighDensityScatterSeries.$$p[3]:
                    this.ue.cl();
                    break;
                case GeographicHighDensityScatterSeries.$$p[1]:
                    this.ue.cj();
                    break;
                case GeographicHighDensityScatterSeries.$$p[2]:
                    this.ue.ck();
                    break;
                case GeographicHighDensityScatterSeries.$$p[0]:
                    this.ue.ci();
                    break;
                case GeographicHighDensityScatterSeries.$$p[7]:
                    this.ue.cp();
                    break;
            }
        }
        get_gg() {
            return true;
        }
        set_gg(a) {
            super.set_gg(a);
        }
    }
    GeographicHighDensityScatterSeries.$t = /*@__PURE__*/ markType(GeographicHighDensityScatterSeries, 'GeographicHighDensityScatterSeries', GeographicMapSeriesHost.$);
    GeographicHighDensityScatterSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, GeographicHighDensityScatterSeries, 'raisePropertyChanged', ['HeatMaximumColor:vc:u2', [Color.$, Defaults.ap], 'HeatMaximum:ui:u3', [1, 50], 'HeatMinimumColor:vd:u4', [Color.$, Defaults.aq], 'HeatMinimum:uj:u5', [1, 0], 'LatitudeMemberPath:us:u6', [2, null], 'LongitudeMemberPath:uu:u7', [2, null], 'MouseOverEnabled:uf:u8', [0, false], 'PointExtent:um:u9', [1, 1], 'ProgressiveLoad:ug:va', [0, true], 'UseBruteForce:uh:vb', [0, false]]);
    return GeographicHighDensityScatterSeries;
})();
