/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { HostSeriesView } from "./HostSeriesView";
import { ScatterSeries } from "igniteui-webcomponents-charts";
import { GeographicMarkerSeries } from "./GeographicMarkerSeries";
import { markType, enumGetBox, runOn, delegateCombine, delegateRemove, markDep } from "igniteui-webcomponents-core";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { CollisionAvoidanceType_$type } from "igniteui-webcomponents-charts";
import { ScatterItemSearchMode_$type } from "igniteui-webcomponents-charts";
import { PropertyMetadata } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export let GeographicSymbolSeriesView = /*@__PURE__*/ (() => {
    class GeographicSymbolSeriesView extends HostSeriesView {
        constructor(a) {
            super(a);
            this.ch = null;
            this.ch = a;
        }
        au() {
            super.au();
            if (!this.q) {
            }
        }
        b5() {
            let a = this.ch.t5;
            super.b5();
            a.xn = this.ch.vt;
            a.xv = this.ch.vr;
            a.uc = this.ch.uf;
            a.uy = this.ch.uv;
            a.uh = this.ch.ug;
        }
        cj() {
            this.ch.t5.xn = this.ch.vt;
        }
        ci() {
            this.ch.t5.xv = this.ch.vr;
        }
        cp() {
            this.ch.t5.uc = this.ch.uf;
        }
        cn() {
            this.ch.t5.uy = this.ch.uv;
        }
        co() {
            this.ch.t5.uh = this.ch.ug;
        }
        cq() {
            this.ch.t5.w3 = this.ch.uh;
        }
        cs() {
            this.ch.t5.xAxis = this.ch.cv.ue;
        }
        ct() {
            this.ch.t5.yAxis = this.ch.cv.ug;
        }
        cr() {
            let a = this.ch.t5;
            if (this.ch.cv == null) {
                a.xAxis = null;
                a.yAxis = null;
                return;
            }
            a.xAxis = this.ch.cv.ue;
            a.yAxis = this.ch.cv.ug;
        }
        cl() {
            this.ch.t5.vo = this.ch.vd;
        }
        ck() {
            this.ch.t5.ve = this.ch.u9;
        }
        cm() {
            this.ch.t5.vf = this.ch.va;
        }
    }
    GeographicSymbolSeriesView.$t = /*@__PURE__*/ markType(GeographicSymbolSeriesView, 'GeographicSymbolSeriesView', HostSeriesView.$);
    return GeographicSymbolSeriesView;
})();
/**
 * @hidden
 */
export let GeographicSymbolSeries = /*@__PURE__*/ (() => {
    class GeographicSymbolSeries extends GeographicMarkerSeries {
        bc() {
            return new GeographicSymbolSeries();
        }
        get_dy() {
            return true;
        }
        constructor() {
            super();
            this.vf = null;
            this.vi = false;
            this.vh = false;
            this.assigningScatterStyle = null;
            this.assigningScatterMarkerStyle = null;
            this.ab = GeographicSymbolSeries.$;
        }
        cd() {
            return new GeographicSymbolSeriesView(this);
        }
        o2(a) {
            super.o2(a);
            this.vg = a;
        }
        ir() {
            return 0.7;
        }
        t4() {
            return new ScatterSeries();
        }
        get_et() {
            return true;
        }
        pa(a, b, c, d) {
            super.pa(a, b, c, d);
            switch (b) {
                case "SeriesViewer":
                    this.vg.cr();
                    break;
                case GeographicSymbolSeries.$$p[5]:
                    this.vg.cj();
                    break;
                case GeographicSymbolSeries.$$p[4]:
                    this.vg.ci();
                    break;
                case GeographicSymbolSeries.$$p[6]:
                    this.vg.cl();
                    break;
                case "XAxis":
                    this.vg.cs();
                    break;
                case "YAxis":
                    this.vg.ct();
                    break;
                case GeographicSymbolSeries.$$p[1]:
                    this.t5.wk = this.vk;
                    this.vi = this.vk;
                    if (this.vk) {
                        let e = this.t5;
                        e.assigningScatterStyle = delegateCombine(e.assigningScatterStyle, runOn(this, this.vy));
                    }
                    else {
                        let f = this.t5;
                        f.assigningScatterStyle = delegateRemove(f.assigningScatterStyle, runOn(this, this.vy));
                    }
                    break;
                case GeographicSymbolSeries.$$p[0]:
                    this.t5.wj = this.vj;
                    this.vh = this.vj;
                    if (this.vk) {
                        let g = this.t5;
                        g.assigningScatterMarkerStyle = delegateCombine(g.assigningScatterMarkerStyle, runOn(this, this.vx));
                    }
                    else {
                        let h = this.t5;
                        h.assigningScatterMarkerStyle = delegateRemove(h.assigningScatterMarkerStyle, runOn(this, this.vx));
                    }
                    break;
                case GeographicSymbolSeries.$$p[2]:
                    this.t5.v3 = this.ve;
                    break;
                case GeographicSymbolSeries.$$p[3]:
                    this.t5.w2 = this.vm;
                    break;
            }
        }
        vy(a, b) {
            if (this.assigningScatterStyle != null) {
                this.assigningScatterStyle(this, b);
            }
        }
        vx(a, b) {
            if (this.assigningScatterMarkerStyle != null) {
                this.assigningScatterMarkerStyle(this, b);
            }
        }
    }
    GeographicSymbolSeries.$t = /*@__PURE__*/ markType(GeographicSymbolSeries, 'GeographicSymbolSeries', GeographicMarkerSeries.$);
    GeographicSymbolSeries.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, GeographicSymbolSeries, 'raisePropertyChanged', ['IsCustomScatterMarkerStyleAllowed:vj:vz', [0, false], 'IsCustomScatterStyleAllowed:vk:v0', [0, false], 'ItemSearchMode:ve:v1', [ScatterItemSearchMode_$type, /*@__PURE__*/ enumGetBox(ScatterItemSearchMode_$type, 0)], 'ItemSearchThreshold:vm:v2', [1, 10000], 'LatitudeMemberPath:vr:v3', [2, null], 'LongitudeMemberPath:vt:v4', [2, null], 'MarkerCollisionAvoidance:vd:v5', [CollisionAvoidanceType_$type, /*@__PURE__*/ enumGetBox(CollisionAvoidanceType_$type, 0)], 'UseLightweightMarkers:vl:v6', [0, false]]);
    return GeographicSymbolSeries;
})();
