/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-webcomponents-core";
/**
 * Indicates the desired behavior for the map on resizing.
 */
export var MapBackgroundTilingMode = /*@__PURE__*/ (function (MapBackgroundTilingMode) {
    /**
     * Indicates that the map should decide the desired tiling mode automatically.
     */
    MapBackgroundTilingMode[MapBackgroundTilingMode["Auto"] = 0] = "Auto";
    /**
     * Map will not wrap tiles around the origin.
     */
    MapBackgroundTilingMode[MapBackgroundTilingMode["NonWrapped"] = 1] = "NonWrapped";
    /**
     * Map will wrap tiles around the origin.
     */
    MapBackgroundTilingMode[MapBackgroundTilingMode["Wrapped"] = 2] = "Wrapped";
    return MapBackgroundTilingMode;
})({});
/**
 * @hidden
 */
export let MapBackgroundTilingMode_$type = /*@__PURE__*/ markEnum('MapBackgroundTilingMode', 'Auto,0|NonWrapped,1|Wrapped,2');
