/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-webcomponents-core";
/**
 * Indicates the desired behavior for the map on resizing.
 */
export var MapResizeBehavior = /*@__PURE__*/ (function (MapResizeBehavior) {
    /**
     * Indicates that the map should decide the desired resize mode automatically.
     */
    MapResizeBehavior[MapResizeBehavior["Auto"] = 0] = "Auto";
    /**
     * Map will attempt to keep the top left position static during resize.
     */
    MapResizeBehavior[MapResizeBehavior["MaintainTopLeftPosition"] = 1] = "MaintainTopLeftPosition";
    /**
     * Map will attempt to keep the center position static during resize.
     */
    MapResizeBehavior[MapResizeBehavior["MaintainCenterPosition"] = 2] = "MaintainCenterPosition";
    return MapResizeBehavior;
})({});
/**
 * @hidden
 */
export let MapResizeBehavior_$type = /*@__PURE__*/ markEnum('MapResizeBehavior', 'Auto,0|MaintainTopLeftPosition,1|MaintainCenterPosition,2');
