/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { GeographicMapImageryView } from "./GeographicMapImageryView";
import { SubDomainsCollection } from "./SubDomainsCollection";
import { GeographicMapImagery } from "./GeographicMapImagery";
import { BingMapsTileSource } from "igniteui-webcomponents-core";
import { markType, String_$type, enumGetBox, runOn, delegateRemove, delegateCombine, markDep } from "igniteui-webcomponents-core";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { BingMapsImageryStyle_$type } from "./BingMapsImageryStyle";
import { List$1 } from "igniteui-webcomponents-core";
import { PropertyMetadata } from "igniteui-webcomponents-core";
import { HttpRequestUtil } from "igniteui-webcomponents-core";
import { Uri } from "igniteui-webcomponents-core";
import { stringEmpty, stringIsNullOrEmpty } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
var BingMapsMapImageryView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BingMapsMapImageryView, _super);
    function BingMapsMapImageryView(a) {
        var _this = _super.call(this, a) || this;
        _this.k = a;
        return _this;
    }
    BingMapsMapImageryView.prototype.m = function () {
        if (this.k.subDomains == null) {
            this.k.subDomains = new SubDomainsCollection(0);
        }
        this.k.ap.tilePath = this.k.actualTilePath;
        this.k.ap.subDomains = this.k.actualSubDomains;
        this.k.ap.cultureName = this.k.cultureName;
    };
    BingMapsMapImageryView.prototype.o = function () {
        this.k.ap.tilePath = this.k.actualTilePath;
    };
    BingMapsMapImageryView.prototype.l = function () {
        this.k.ap.cultureName = this.k.cultureName;
    };
    BingMapsMapImageryView.prototype.n = function () {
        this.k.ap.subDomains = this.k.actualSubDomains;
    };
    BingMapsMapImageryView.$t = markType(BingMapsMapImageryView, 'BingMapsMapImageryView', GeographicMapImageryView.$);
    return BingMapsMapImageryView;
}(GeographicMapImageryView));
export { BingMapsMapImageryView };
/**
 * @hidden
 */
var BingMapsMapImagery = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BingMapsMapImagery, _super);
    function BingMapsMapImagery() {
        var _this = _super.call(this, new BingMapsTileSource(0)) || this;
        _this._pendingBingRequest_ = null;
        _this._isInitialized = false;
        _this.bz = null;
        _this.bq = null;
        _this.b0 = null;
        _this.by = null;
        _this.getResponseCompleted = _this.getResponseCompleted.bind(_this);
        _this.bp.m();
        _this.actualBingImageryRestUri = BingMapsMapImagery.cc;
        return _this;
    }
    BingMapsMapImagery.prototype.ai = function () {
        return new BingMapsMapImageryView(this);
    };
    BingMapsMapImagery.prototype.bb = function (a) {
        _super.prototype.bb.call(this, a);
        this.bp = a;
    };
    Object.defineProperty(BingMapsMapImagery.prototype, "isInitialized", {
        get: function () {
            return this._isInitialized;
        },
        set: function (a) {
            this._isInitialized = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BingMapsMapImagery.prototype, "actualTilePath", {
        get: function () {
            return this.bz;
        },
        set: function (a) {
            var b = this.bz;
            this.bz = a;
            this.cm("ActualTilePath", b, this.bz);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BingMapsMapImagery.prototype, "actualSubDomains", {
        get: function () {
            return this.bq;
        },
        set: function (a) {
            var b = this.bq;
            this.bq = a;
            this.cm("ActualSubDomains", b, this.bq);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BingMapsMapImagery.prototype, "bingImageryRestUri", {
        get: function () {
            return this.b0;
        },
        set: function (a) {
            var b = this.b0;
            this.b0 = a;
            this.cm("BingImageryRestUri", b, this.b0);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(BingMapsMapImagery.prototype, "actualBingImageryRestUri", {
        get: function () {
            return this.by;
        },
        set: function (a) {
            var b = this.by;
            this.by = a;
            this.ba("ActualBingImageryRestUri", b, this.by);
        },
        enumerable: false,
        configurable: true
    });
    BingMapsMapImagery.prototype.requestMapSettings = function () {
        this.co(true);
    };
    BingMapsMapImagery.prototype.co = function (a) {
        this.cl(a);
    };
    BingMapsMapImagery.prototype.bw = function () {
        if ((this.tilePath == null) && (this.subDomains == null)) {
            return true;
        }
        return false;
    };
    BingMapsMapImagery.prototype.cq = function () {
        this.isInitialized = false;
        if (!this.bv()) {
            this.cp("", null);
            return;
        }
        if (!this.isDeferredLoad) {
            this.co(false);
        }
    };
    BingMapsMapImagery.prototype.bv = function () {
        if (stringIsNullOrEmpty(this.apiKey) || this.apiKey.length < 20) {
            return false;
        }
        return true;
    };
    BingMapsMapImagery.prototype.cj = function () {
    };
    BingMapsMapImagery.prototype.cp = function (a, b) {
        if (a != this.actualTilePath) {
            this.actualTilePath = a;
        }
        var c = b == null ? null : new SubDomainsCollection(1, b);
        if (this.actualSubDomains != c) {
            this.actualSubDomains = c;
        }
        this.bp.m();
    };
    BingMapsMapImagery.prototype.cl = function (a) {
        if ((!a) && (this.isDeferredLoad)) {
            return;
        }
        if (!this.bv()) {
            this.isInitialized = false;
            this.cp("", null);
            return;
        }
        this.isInitialized = true;
        var b = null;
        if (this.bingImageryRestUri != null) {
            if (Uri.isWellFormedUriString(this.bingImageryRestUri, 1)) {
                b = this.bingImageryRestUri;
            }
        }
        else {
            if (Uri.isWellFormedUriString(this.actualBingImageryRestUri, 1)) {
                b = this.actualBingImageryRestUri;
            }
        }
        if (b == null) {
            this.cp("", null);
            return;
        }
        var c = this.imageryStyle;
        b += enumGetBox(BingMapsImageryStyle_$type, c);
        var d = "key=" + this.apiKey + "&include=ImageryProviders";
        var url_ = b + "?" + d;
        this._pendingBingRequest_ = HttpRequestUtil.submit(url_, this.getResponseCompleted, null);
    };
    BingMapsMapImagery.prototype.getResponseCompleted = function (a, b) {
        if (b != this._pendingBingRequest_) {
            return;
        }
        this._pendingBingRequest_ = null;
        var data_ = a;
        var resourceSets_ = JSON.parse(data_).resourceSets;
        if (resourceSets_ == null) {
            return;
        }
        var resources_ = resourceSets_.length > 0 ? resourceSets_[0].resources : null;
        if (resources_ == null) {
            return;
        }
        if (resources_.length == 0) {
            return;
        }
        ;
        var imageUrl_ = (resources_[0].imageUrl);
        var subDomains_ = new List$1(String_$type, 0);
        for (var i = 0; i < resources_[0].imageUrlSubdomains.length; i++) {
            subDomains_.add(resources_[0].imageUrlSubdomains[i]);
        }
        ;
        this.cp(imageUrl_, subDomains_);
    };
    BingMapsMapImagery.prototype.ci = function (a, b) {
        this.aj.e();
        this.cq();
        this.cm(BingMapsMapImagery.$$p[4], this.actualSubDomains, this.actualSubDomains);
    };
    BingMapsMapImagery.prototype.cm = function (a, b, c) {
        switch (a) {
            case BingMapsMapImagery.$$p[0]:
                this.cq();
                break;
            case BingMapsMapImagery.$$p[3]:
                this.cq();
                break;
            case BingMapsMapImagery.$$p[5]:
                this.cj();
                this.actualTilePath = c;
                this.bp.o();
                this.aj.e();
                break;
            case BingMapsMapImagery.$$p[1]:
                this.bp.l();
                this.aj.e();
                break;
            case BingMapsMapImagery.$$p[2]:
                this.cq();
                break;
            case BingMapsMapImagery.$$p[4]:
                this.cj();
                var d = b;
                var e = c;
                if (this.actualSubDomains != null) {
                    var f = this.actualSubDomains;
                    f.collectionChanged = delegateRemove(f.collectionChanged, runOn(this, this.ci));
                }
                this.actualSubDomains = e;
                if (this.actualSubDomains != null) {
                    e.collectionChanged = delegateCombine(e.collectionChanged, runOn(this, this.ci));
                }
                this.bp.n();
                this.aj.e();
                break;
            case "ActualTilePath":
                var g = c;
                if (stringIsNullOrEmpty(g)) {
                    this.cq();
                }
                break;
            case "BingImageryRestUri":
                this.actualBingImageryRestUri = c;
                this.cj();
                this.cq();
                break;
            case "ActualBingImageryRestUri":
                this.cj();
                this.cq();
                break;
        }
        _super.prototype.ba.call(this, a, b, c);
    };
    BingMapsMapImagery.$t = markType(BingMapsMapImagery, 'BingMapsMapImagery', GeographicMapImagery.$);
    BingMapsMapImagery.cc = "http://dev.virtualearth.net/REST/v1/Imagery/Metadata/";
    BingMapsMapImagery.$$p = markDep(DependencyProperty, PropertyMetadata, BingMapsMapImagery, 'cm', ['ApiKey', [2, stringEmpty()], 'CultureName', [2, "en-US"], 'ImageryStyle', [BingMapsImageryStyle_$type, enumGetBox(BingMapsImageryStyle_$type, 1)], 'IsDeferredLoad', [0, false], 'SubDomains', [SubDomainsCollection.$, null], 'TilePath', [2, null]]);
    return BingMapsMapImagery;
}(GeographicMapImagery));
export { BingMapsMapImagery };
