/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { GeographicXYTriangulatingSeriesView } from "./GeographicXYTriangulatingSeriesView";
import { Defaults } from "igniteui-webcomponents-charts";
import { ScatterContourSeries } from "igniteui-webcomponents-charts";
import { markType, runOn, delegateCombine, typeCast, markDep } from "igniteui-webcomponents-core";
import { GeographicXYTriangulatingSeries } from "./GeographicXYTriangulatingSeries";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { ValueBrushScale } from "igniteui-webcomponents-charts";
import { ContourValueResolver } from "igniteui-webcomponents-charts";
import { PropertyMetadata } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
var GeographicContourLineSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicContourLineSeriesView, _super);
    function GeographicContourLineSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.cp = null;
        _this.cp = a;
        return _this;
    }
    GeographicContourLineSeriesView.prototype.au = function () {
        _super.prototype.au.call(this);
        if (!this.q) {
            this.cp.iv = Defaults.m;
        }
    };
    GeographicContourLineSeriesView.prototype.b5 = function () {
        _super.prototype.b5.call(this);
        if (this.cp.t5 != null) {
            this.cp.ux.v0 = this.cp.u0;
            this.cp.ux.wa = this.cp.u4;
        }
    };
    GeographicContourLineSeriesView.prototype.cq = function () {
        if (this.cp.ux != null) {
            this.cp.ux.v0 = this.cp.u0;
        }
    };
    GeographicContourLineSeriesView.prototype.cr = function () {
        if (this.cp.ux != null) {
            this.cp.ux.wa = this.cp.u4;
        }
    };
    GeographicContourLineSeriesView.$t = markType(GeographicContourLineSeriesView, 'GeographicContourLineSeriesView', GeographicXYTriangulatingSeriesView.$);
    return GeographicContourLineSeriesView;
}(GeographicXYTriangulatingSeriesView));
export { GeographicContourLineSeriesView };
/**
 * @hidden
 */
var GeographicContourLineSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicContourLineSeries, _super);
    function GeographicContourLineSeries() {
        var _this = _super.call(this) || this;
        _this.triangulationStatusChanged = null;
        _this.ab = GeographicContourLineSeries.$;
        return _this;
    }
    GeographicContourLineSeries.prototype.bc = function () {
        return new GeographicContourLineSeries();
    };
    GeographicContourLineSeries.prototype.get_ex = function () {
        return true;
    };
    GeographicContourLineSeries.prototype.ua = function () {
        _super.prototype.ua.call(this);
    };
    GeographicContourLineSeries.prototype.t4 = function () {
        this.ux = new ScatterContourSeries();
        var a = this.ux;
        a.triangulationStatusChanged = delegateCombine(a.triangulationStatusChanged, runOn(this, this.u7));
        var b = this.ux;
        b.propertyUpdated = delegateCombine(b.propertyUpdated, runOn(this, this.u8));
        return this.ux;
    };
    GeographicContourLineSeries.prototype.u7 = function (a, b) {
        if (this.triangulationStatusChanged != null) {
            this.triangulationStatusChanged(this, b);
        }
    };
    GeographicContourLineSeries.prototype.u8 = function (a, b) {
        var c = typeCast(ScatterContourSeries.$, this.t5);
        if (c == null) {
            return;
        }
        if (b.propertyName == "ActualFillScale") {
            this.uz = c.vz;
        }
    };
    GeographicContourLineSeries.prototype.qf = function () {
        _super.prototype.qf.call(this);
    };
    GeographicContourLineSeries.prototype.cd = function () {
        return new GeographicContourLineSeriesView(this);
    };
    GeographicContourLineSeries.prototype.o2 = function (a) {
        _super.prototype.o2.call(this, a);
        this.u1 = a;
    };
    GeographicContourLineSeries.prototype.pa = function (a, b, c, d) {
        _super.prototype.pa.call(this, a, b, c, d);
        switch (b) {
            case GeographicContourLineSeries.$$p[1]:
                this.u1.cq();
                break;
            case GeographicContourLineSeries.$$p[2]:
                this.u1.cr();
                break;
            case GeographicContourLineSeries.$$p[3]:
                this.ux.vx = this.uw;
                break;
            case "DashArray":
                this.ux.s9 = this.s9;
                break;
            case "DashCap":
                this.ux.ta = this.ta;
                break;
            case "MiterLimit":
                this.ux.im = this.im;
                break;
            case "LineJoin":
                this.ux.tc = this.tc;
                break;
        }
    };
    GeographicContourLineSeries.$t = markType(GeographicContourLineSeries, 'GeographicContourLineSeries', GeographicXYTriangulatingSeries.$);
    GeographicContourLineSeries.$$p = markDep(DependencyProperty, PropertyMetadata, GeographicContourLineSeries, 'raisePropertyChanged', ['ActualFillScale:uz:u9', [ValueBrushScale.$, null], 'FillScale:u0:va', [ValueBrushScale.$, null], 'ValueMemberPath:u4:vb', [2, "value"], 'ValueResolver:uw:vc', [ContourValueResolver.$, null]]);
    return GeographicContourLineSeries;
}(GeographicXYTriangulatingSeries));
export { GeographicContourLineSeries };
