/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { HostSeriesView } from "./HostSeriesView";
import { HighDensityScatterSeries } from "igniteui-webcomponents-charts";
import { GeographicMapSeriesHost } from "./GeographicMapSeriesHost";
import { Color } from "igniteui-webcomponents-core";
import { Defaults } from "igniteui-webcomponents-charts";
import { typeCast, markType, runOn, delegateCombine, markDep } from "igniteui-webcomponents-core";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { PropertyMetadata } from "igniteui-webcomponents-core";
import { isNaN_ } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
var GeographicHighDensityScatterSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicHighDensityScatterSeriesView, _super);
    function GeographicHighDensityScatterSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.ch = null;
        _this.ch = a;
        return _this;
    }
    GeographicHighDensityScatterSeriesView.prototype.b5 = function () {
        _super.prototype.b5.call(this);
        var a = typeCast(HighDensityScatterSeries.$, this.ch.t5);
        a.wd = this.ch.uu;
        a.wl = this.ch.us;
        a.uq = this.ch.uh;
        a.up = this.ch.ug;
        a.fl = this.ch.uf;
        a.vl = this.ch.uj;
        a.vk = this.ch.ui;
        a.xj = this.ch.vd;
        a.xi = this.ch.vc;
        a.vx = this.ch.um;
    };
    GeographicHighDensityScatterSeriesView.prototype.cn = function () {
        this.ch.t5.wd = this.ch.uu;
    };
    GeographicHighDensityScatterSeriesView.prototype.cm = function () {
        this.ch.t5.wl = this.ch.us;
    };
    GeographicHighDensityScatterSeriesView.prototype.cs = function () {
        this.ch.t5.uq = this.ch.uh;
    };
    GeographicHighDensityScatterSeriesView.prototype.cq = function () {
        this.ch.t5.up = this.ch.ug;
    };
    GeographicHighDensityScatterSeriesView.prototype.co = function () {
        this.ch.t5.fl = this.ch.uf;
    };
    GeographicHighDensityScatterSeriesView.prototype.cl = function () {
        this.ch.t5.vl = this.ch.uj;
    };
    GeographicHighDensityScatterSeriesView.prototype.cj = function () {
        this.ch.t5.vk = this.ch.ui;
    };
    GeographicHighDensityScatterSeriesView.prototype.cr = function () {
        var a = typeCast(HighDensityScatterSeries.$, this.ch.t5);
        if (this.ch.cv == null) {
            a.ua = null;
            a.uc = null;
            return;
        }
        a.ua = this.ch.cv.ue;
        a.uc = this.ch.cv.ug;
    };
    GeographicHighDensityScatterSeriesView.prototype.ct = function () {
        this.ch.t5.ua = this.ch.cv.ue;
    };
    GeographicHighDensityScatterSeriesView.prototype.cu = function () {
        this.ch.t5.uc = this.ch.cv.ug;
    };
    GeographicHighDensityScatterSeriesView.prototype.ck = function () {
        this.ch.t5.xj = this.ch.vd;
    };
    GeographicHighDensityScatterSeriesView.prototype.ci = function () {
        this.ch.t5.xi = this.ch.vc;
    };
    GeographicHighDensityScatterSeriesView.prototype.cp = function () {
        this.ch.t5.vx = this.ch.um;
    };
    GeographicHighDensityScatterSeriesView.prototype.au = function () {
        _super.prototype.au.call(this);
        if (!this.q) {
            this.ch.vd = Defaults.aq;
            this.ch.vc = Defaults.ap;
            this.ch.sy = Defaults.al;
            this.ch.s4 = Defaults.ak;
        }
    };
    GeographicHighDensityScatterSeriesView.$t = markType(GeographicHighDensityScatterSeriesView, 'GeographicHighDensityScatterSeriesView', HostSeriesView.$);
    return GeographicHighDensityScatterSeriesView;
}(HostSeriesView));
export { GeographicHighDensityScatterSeriesView };
/**
 * @hidden
 */
var GeographicHighDensityScatterSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicHighDensityScatterSeries, _super);
    function GeographicHighDensityScatterSeries() {
        var _this = _super.call(this) || this;
        _this.ud = null;
        _this.progressiveLoadStatusChanged = null;
        _this.ul = 0;
        _this.ab = GeographicHighDensityScatterSeries.$;
        return _this;
    }
    GeographicHighDensityScatterSeries.prototype.bc = function () {
        return new GeographicHighDensityScatterSeries();
    };
    GeographicHighDensityScatterSeries.prototype.iq = function () {
        if (!isNaN_(this.ip)) {
            return _super.prototype.iq.call(this);
        }
        return Defaults.q;
    };
    GeographicHighDensityScatterSeries.prototype.get_e2 = function () {
        return true;
    };
    GeographicHighDensityScatterSeries.prototype.cd = function () {
        return new GeographicHighDensityScatterSeriesView(this);
    };
    GeographicHighDensityScatterSeries.prototype.o2 = function (a) {
        _super.prototype.o2.call(this, a);
        this.ue = a;
    };
    GeographicHighDensityScatterSeries.prototype.t4 = function () {
        this.ud = new HighDensityScatterSeries();
        return this.ud;
    };
    Object.defineProperty(GeographicHighDensityScatterSeries.prototype, "un", {
        get: function () {
            return this.ul;
        },
        set: function (a) {
            var b = this.ul;
            this.ul = a;
            this.raisePropertyChanged("ProgressiveStatus", b, this.ul);
        },
        enumerable: false,
        configurable: true
    });
    GeographicHighDensityScatterSeries.prototype.ua = function () {
        _super.prototype.ua.call(this);
        var a = this.t5;
        a.progressiveLoadStatusChanged = delegateCombine(a.progressiveLoadStatusChanged, runOn(this, this.u1));
        var b = this.t5;
        b.propertyUpdated = delegateCombine(b.propertyUpdated, runOn(this, this.u0));
    };
    GeographicHighDensityScatterSeries.prototype.u1 = function (a, b) {
        this.un = b.currentStatus;
        if (this.progressiveLoadStatusChanged != null) {
            this.progressiveLoadStatusChanged(this, b);
        }
    };
    GeographicHighDensityScatterSeries.prototype.u0 = function (a, b) {
        if (this.ud == null) {
            return;
        }
    };
    GeographicHighDensityScatterSeries.prototype.pa = function (a, b, c, d) {
        _super.prototype.pa.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                this.ue.cr();
                break;
            case GeographicHighDensityScatterSeries.$$p[5]:
                this.ue.cn();
                break;
            case GeographicHighDensityScatterSeries.$$p[4]:
                this.ue.cm();
                break;
            case GeographicHighDensityScatterSeries.$$p[9]:
                this.ue.cs();
                break;
            case GeographicHighDensityScatterSeries.$$p[8]:
                this.ue.cq();
                break;
            case GeographicHighDensityScatterSeries.$$p[6]:
                this.ue.co();
                break;
            case "XAxis":
                this.ue.ct();
                break;
            case "YAxis":
                this.ue.cu();
                break;
            case GeographicHighDensityScatterSeries.$$p[3]:
                this.ue.cl();
                break;
            case GeographicHighDensityScatterSeries.$$p[1]:
                this.ue.cj();
                break;
            case GeographicHighDensityScatterSeries.$$p[2]:
                this.ue.ck();
                break;
            case GeographicHighDensityScatterSeries.$$p[0]:
                this.ue.ci();
                break;
            case GeographicHighDensityScatterSeries.$$p[7]:
                this.ue.cp();
                break;
        }
    };
    GeographicHighDensityScatterSeries.prototype.get_gg = function () {
        return true;
    };
    GeographicHighDensityScatterSeries.prototype.set_gg = function (a) {
        _super.prototype.set_gg.call(this, a);
    };
    GeographicHighDensityScatterSeries.$t = markType(GeographicHighDensityScatterSeries, 'GeographicHighDensityScatterSeries', GeographicMapSeriesHost.$);
    GeographicHighDensityScatterSeries.$$p = markDep(DependencyProperty, PropertyMetadata, GeographicHighDensityScatterSeries, 'raisePropertyChanged', ['HeatMaximumColor:vc:u2', [Color.$, Defaults.ap], 'HeatMaximum:ui:u3', [1, 50], 'HeatMinimumColor:vd:u4', [Color.$, Defaults.aq], 'HeatMinimum:uj:u5', [1, 0], 'LatitudeMemberPath:us:u6', [2, null], 'LongitudeMemberPath:uu:u7', [2, null], 'MouseOverEnabled:uf:u8', [0, false], 'PointExtent:um:u9', [1, 1], 'ProgressiveLoad:ug:va', [0, true], 'UseBruteForce:uh:vb', [0, false]]);
    return GeographicHighDensityScatterSeries;
}(GeographicMapSeriesHost));
export { GeographicHighDensityScatterSeries };
