/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Series } from "igniteui-webcomponents-charts";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { typeCast, Number_$type, runOn, delegateRemove, delegateCombine, markType, TypeRegistrar } from "igniteui-webcomponents-core";
import { SeriesView } from "igniteui-webcomponents-charts";
import { SeriesViewer } from "igniteui-webcomponents-charts";
import { PropertyMetadata } from "igniteui-webcomponents-core";
import { PlatformConstants } from "igniteui-webcomponents-core";
import { isNaN_ } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
var GeographicMapSeriesHost = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicMapSeriesHost, _super);
    function GeographicMapSeriesHost() {
        var _this = _super.call(this) || this;
        _this.t3 = null;
        _this.t5 = _this.t4();
        return _this;
    }
    GeographicMapSeriesHost.prototype.oh = function () {
        _super.prototype.oh.call(this);
        if (this.t5 != null) {
            this.t5.oh();
        }
    };
    GeographicMapSeriesHost.prototype.get_er = function () {
        return true;
    };
    GeographicMapSeriesHost.prototype.jv = function (a, b) {
        var c = this.lw(b);
        if (c == "LatitudeMemberPath") {
            c = "YMemberPath";
        }
        if (c == "LongitudeMemberPath") {
            c = "XMemberPath";
        }
        return this.t5.jv(a, b);
    };
    GeographicMapSeriesHost.prototype.dt = function (a, b, c, d) {
        return this.t5.dt(a, b, c, d);
    };
    GeographicMapSeriesHost.prototype.ag = function () {
        return this.t5.ag();
    };
    GeographicMapSeriesHost.prototype.bg = function () {
        return this.t5;
    };
    Object.defineProperty(GeographicMapSeriesHost.prototype, "t5", {
        get: function () {
            return this.t3;
        },
        set: function (a) {
            var b = this.t5 != a;
            if (b) {
                this.t3 = a;
                this.ua();
            }
        },
        enumerable: false,
        configurable: true
    });
    GeographicMapSeriesHost.prototype.get_hasMarkers = function () {
        return this.t5.hasMarkers;
    };
    GeographicMapSeriesHost.prototype.ua = function () {
        if (this.t3 != null) {
            var hostedSeries_ = this.t3;
            hostedSeries_.externalObject = TypeRegistrar.createFromInternal(hostedSeries_, PlatformConstants.Prefix, PlatformConstants.Postfix);
            hostedSeries_.externalObject._implementation = hostedSeries_;
        }
        this.ns(this.t5);
        this.t6.b5();
    };
    GeographicMapSeriesHost.prototype.c0 = function (a, b, c) {
        return this.c2(this.t5, a, b, c);
    };
    GeographicMapSeriesHost.prototype.c1 = function (a, b, c) {
        return this.c3(this.t5, a, b, c);
    };
    GeographicMapSeriesHost.prototype.js = function (a) {
        return this.jy(this.t5, a);
    };
    GeographicMapSeriesHost.prototype.jg = function (a, b) {
        return this.t5.jg(a, b);
    };
    GeographicMapSeriesHost.prototype.je = function (a, b) {
        return this.t5.je(a, b);
    };
    GeographicMapSeriesHost.prototype.ia = function (a, b, c) {
        return this.t5.ia(a, b, c);
    };
    GeographicMapSeriesHost.prototype.tj = function (a, b, c) {
        return this.t5.tj(a, b, c);
    };
    GeographicMapSeriesHost.prototype.tu = function (a) {
        return this.t5.tu(a);
    };
    GeographicMapSeriesHost.prototype.ak = function (a) {
        return this.t5.ak(a);
    };
    GeographicMapSeriesHost.prototype.tv = function (a) {
        return this.t5.tv(a);
    };
    GeographicMapSeriesHost.prototype.al = function (a) {
        return this.t5.al(a);
    };
    GeographicMapSeriesHost.prototype.tw = function (a) {
        return this.t5.tw(a);
    };
    GeographicMapSeriesHost.prototype.tx = function (a) {
        return this.t5.tx(a);
    };
    GeographicMapSeriesHost.prototype.h6 = function (a, b, c) {
        return this.t5.h6(a, b, c);
    };
    GeographicMapSeriesHost.prototype.tf = function (a, b, c) {
        return this.t5.tf(a, b, c);
    };
    GeographicMapSeriesHost.prototype.h8 = function (a, b, c) {
        return this.ia(a, b, c);
    };
    GeographicMapSeriesHost.prototype.th = function (a, b, c) {
        return this.t5.th(a, b, c);
    };
    GeographicMapSeriesHost.prototype.tk = function (a, b, c) {
        return this.t5.tk(a, b, c);
    };
    GeographicMapSeriesHost.prototype.ib = function (a, b, c) {
        return this.t5.ib(a, b, c);
    };
    GeographicMapSeriesHost.prototype.tg = function (a, b, c) {
        return this.t5.tg(a, b, c);
    };
    GeographicMapSeriesHost.prototype.h7 = function (a, b, c) {
        return this.t5.h7(a, b, c);
    };
    GeographicMapSeriesHost.prototype.ti = function (a, b, c) {
        return this.t5.ti(a, b, c);
    };
    GeographicMapSeriesHost.prototype.h9 = function (a, b, c) {
        return this.t5.h9(a, b, c);
    };
    GeographicMapSeriesHost.prototype.ja = function (a) {
        return this.t5.ja(a);
    };
    GeographicMapSeriesHost.prototype.h1 = function () {
        return this.t5.h1();
    };
    GeographicMapSeriesHost.prototype.hx = function (a) {
        return this.t5.hx(a);
    };
    GeographicMapSeriesHost.prototype.jt = function (a) {
        return this.t5.jt(a);
    };
    GeographicMapSeriesHost.prototype.cd = function () {
        return new HostSeriesView(this);
    };
    GeographicMapSeriesHost.prototype.o2 = function (a) {
        _super.prototype.o2.call(this, a);
        this.t6 = typeCast(HostSeriesView.$, a);
    };
    Object.defineProperty(GeographicMapSeriesHost.prototype, "t7", {
        get: function () {
            return this.c(GeographicMapSeriesHost.uc);
        },
        set: function (a) {
            this.h(GeographicMapSeriesHost.uc, a);
        },
        enumerable: false,
        configurable: true
    });
    GeographicMapSeriesHost.prototype.pa = function (a, b, c, d) {
        _super.prototype.pa.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                this.t5.cv = this.cv;
                if (c != null) {
                    c.o6(this.t5);
                }
                if (d != null) {
                    this.cv.ls(this.t5);
                }
                this.t5.pd(this.ty);
                this.t5.index = this.index;
                this.n3(this.t5);
                this.jm = this.t5.jm;
                var e = typeCast(SeriesViewer.$, c);
                if (e != null) {
                    e.actualWindowRectChanged = delegateRemove(e.actualWindowRectChanged, runOn(this, this.ub));
                }
                if (this.cv != null) {
                    var f = this.cv;
                    f.actualWindowRectChanged = delegateCombine(f.actualWindowRectChanged, runOn(this, this.ub));
                }
                this.t9();
                break;
            case "SyncLink":
                this.t5.co = this.co;
                break;
            case "VisibleFromScale":
                this.t9();
                break;
            case "Index":
                this.t5.index = this.index;
                break;
            case "ItemsSource":
                this.t6.b6();
                break;
            case "Resolution":
                this.t6.cd();
                break;
            case "TransitionDuration":
                this.t6.cg();
                break;
            case "Opacity":
                this.t6.ca();
                break;
            case "Visibility":
                var hs_ = this.t5;
                var v_ = this._visibility;
                hs_.visibility = v_;
                break;
            case "MouseOverEnabled":
                this.t5.fl = this.fl;
                break;
            case "ExpectFunctions":
                this.t5.expectFunctions = this.expectFunctions;
                break;
            case "Thickness":
                this.t6.cf();
                break;
            case "Brush":
                this.t6.b4();
                break;
            case "Outline":
                this.t6.cc();
                break;
            case "ActualBrush":
                this.t6.b1();
                break;
            case "ActualOutline":
                this.t6.b2();
                break;
            case "MarkerFillOpacity":
                if (!isNaN_(this.il)) {
                    this.t6.b9();
                }
                break;
            case "AreaFillOpacity":
                if (!isNaN_(this.hq)) {
                    this.t6.b3();
                }
                break;
            case "OutlineMode":
                this.t6.cb();
                break;
            case "ShowDefaultTooltip":
                this.t6.ce();
                break;
            case "Title":
                this.t5.title = this.title;
                break;
            case "LegendItemBadgeMode":
                this.t6.b7();
                break;
            case "LegendItemBadgeShape":
                this.t6.b8();
                break;
            case "Legend":
                this.t5.legend = this.legend;
                this.cg.av();
                break;
        }
    };
    GeographicMapSeriesHost.prototype.t9 = function () {
        if (this.cv == null || this.t5 == null) {
            return;
        }
        if (!isNaN_(this.t7)) {
            if (this.cv.tr.width > this.t7) {
                var hs_ = this.t5;
                var v_ = 1;
                hs_.visibility = v_;
            }
            else {
                var hs2_ = this.t5;
                var v2_ = 0;
                hs2_.visibility = v2_;
            }
        }
    };
    GeographicMapSeriesHost.prototype.ub = function (a, b) {
        this.t9();
    };
    GeographicMapSeriesHost.prototype.pr = function (a) {
        _super.prototype.pr.call(this, a);
        if (this.t5 != null) {
            this.t5.pr(a);
        }
    };
    GeographicMapSeriesHost.prototype.pq = function (a, b, c, d, e) {
        if (this.t5 != null) {
            this.t5.pq(a, b, c, d, e);
        }
    };
    GeographicMapSeriesHost.prototype.au = function (a, b) {
        return this.t5.au(a, b);
    };
    GeographicMapSeriesHost.prototype.qa = function () {
        _super.prototype.qa.call(this);
        this.t5.qa();
    };
    GeographicMapSeriesHost.prototype.get_coercionMethods = function () {
        return this._coercionMethods;
    };
    GeographicMapSeriesHost.prototype.set_coercionMethods = function (a) {
        this._coercionMethods = a;
        this.t5.coercionMethods = a;
    };
    GeographicMapSeriesHost.prototype.n2 = function (a) {
        _super.prototype.n2.call(this, a);
        if (this.t5 != null) {
            var b = this.t5.jr();
            this.nn(a, b);
        }
    };
    GeographicMapSeriesHost.$t = markType(GeographicMapSeriesHost, 'GeographicMapSeriesHost', Series.$);
    GeographicMapSeriesHost.uc = DependencyProperty.i("VisibleFromScale", Number_$type, GeographicMapSeriesHost.$, new PropertyMetadata(2, 1, function (a, b) {
        var c = a;
        c.raisePropertyChanged("VisibleFromScale", b.oldValue, b.newValue);
    }));
    return GeographicMapSeriesHost;
}(Series));
export { GeographicMapSeriesHost };
/**
 * @hidden
 */
var HostSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(HostSeriesView, _super);
    function HostSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.b0 = null;
        _this.b0 = a;
        return _this;
    }
    HostSeriesView.prototype.at = function (a, b) {
        _super.prototype.at.call(this, a, b);
    };
    HostSeriesView.prototype.b5 = function () {
        this.b0.t2 = 1;
        this.b0.t5.t2 = 0;
        this.b0.t5.itemsSource = this.b0.itemsSource;
        this.b0.t5.index = this.b0.index;
        this.b0.t5.sy = this.b0.sy;
        this.b0.t5.s4 = this.b0.sy;
        this.b0.t5.b9 = this.b0.b9;
        this.b0.t5.ip = this.b0.ip;
        this.b0.t5.jj = this.b0.jj;
        this.b0.t5._opacity = this.b0._opacity;
        this.b0.t5.iv = this.b0.iv;
        this.b0.t5.hq = this.b0.hq;
        this.b0.t5.il = this.b0.il;
        this.b0.t5.fz = this.b0.fz;
        this.b0.t5.legendItemBadgeShape = this.b0.legendItemBadgeShape;
        this.b0.t5.a6 = this.b0.a6;
    };
    HostSeriesView.prototype.b6 = function () {
        this.b0.t5.itemsSource = this.b0.itemsSource;
    };
    HostSeriesView.prototype.cd = function () {
        this.b0.t5.ip = this.b0.ip;
    };
    HostSeriesView.prototype.cg = function () {
        this.b0.t5.jj = this.b0.jj;
    };
    HostSeriesView.prototype.ca = function () {
        this.b0.t5._opacity = this.b0._opacity;
    };
    HostSeriesView.prototype.cf = function () {
        this.b0.t5.iv = this.b0.iv;
    };
    HostSeriesView.prototype.b4 = function () {
        this.b0.t5.sy = this.b0.sy;
    };
    HostSeriesView.prototype.cc = function () {
        this.b0.t5.s4 = this.b0.s4;
    };
    HostSeriesView.prototype.b1 = function () {
        this.b0.t5.sy = this.b0.su;
    };
    HostSeriesView.prototype.b2 = function () {
        this.b0.t5.s4 = this.b0.sx;
    };
    HostSeriesView.prototype.b7 = function () {
        this.b0.t5.a6 = this.b0.a6;
    };
    HostSeriesView.prototype.b8 = function () {
        this.b0.t5.legendItemBadgeShape = this.b0.legendItemBadgeShape;
    };
    HostSeriesView.prototype.b3 = function () {
        this.b0.t5.hq = this.b0.hq;
    };
    HostSeriesView.prototype.b9 = function () {
        this.b0.t5.il = this.b0.il;
    };
    HostSeriesView.prototype.cb = function () {
        this.b0.t5.b9 = this.b0.b9;
    };
    HostSeriesView.prototype.ce = function () {
        this.b0.t5.fz = this.b0.fz;
    };
    HostSeriesView.$t = markType(HostSeriesView, 'HostSeriesView', SeriesView.$);
    return HostSeriesView;
}(SeriesView));
export { HostSeriesView };
