/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { GeographicMapSeriesHost } from "./GeographicMapSeriesHost";
import { DependencyProperty } from "igniteui-webcomponents-core";
import { ShapeItemSearchMode_$type } from "igniteui-webcomponents-charts";
import { enumGetBox, runOn, delegateCombine, delegateRemove, markType, markDep } from "igniteui-webcomponents-core";
import { PropertyMetadata } from "igniteui-webcomponents-core";
import { HostSeriesView } from "./HostSeriesView";
/**
 * @hidden
 */
var GeographicShapeSeriesBase = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicShapeSeriesBase, _super);
    function GeographicShapeSeriesBase() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.ul = false;
        _this.uk = false;
        _this.assigningShapeStyle = null;
        _this.assigningShapeMarkerStyle = null;
        _this.uh = null;
        _this.uj = false;
        return _this;
    }
    GeographicShapeSeriesBase.prototype.cd = function () {
        return new GeographicShapeSeriesBaseView(this);
    };
    GeographicShapeSeriesBase.prototype.o2 = function (a) {
        _super.prototype.o2.call(this, a);
        this.ug = a;
    };
    GeographicShapeSeriesBase.prototype.get_et = function () {
        return true;
    };
    GeographicShapeSeriesBase.prototype.get_dv = function () {
        return true;
    };
    GeographicShapeSeriesBase.prototype.pa = function (a, b, c, d) {
        _super.prototype.pa.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                this.ug.ci();
                break;
            case "ShapeMemberPath":
                this.ug.ck();
                break;
            case GeographicShapeSeriesBase.$$p[5]:
                this.ug.cj();
                break;
            case GeographicShapeSeriesBase.$$p[1]:
                this.t5.u4 = this.un;
                this.ul = this.un;
                if (this.un) {
                    var e = this.t5;
                    e.assigningShapeStyle = delegateCombine(e.assigningShapeStyle, runOn(this, this.u1));
                }
                else {
                    var f = this.t5;
                    f.assigningShapeStyle = delegateRemove(f.assigningShapeStyle, runOn(this, this.u1));
                }
                break;
            case GeographicShapeSeriesBase.$$p[0]:
                this.t5.u3 = this.um;
                this.uk = this.um;
                if (this.un) {
                    var g = this.t5;
                    g.assigningShapeMarkerStyle = delegateCombine(g.assigningShapeMarkerStyle, runOn(this, this.u0));
                }
                else {
                    var h = this.t5;
                    h.assigningShapeMarkerStyle = delegateRemove(h.assigningShapeMarkerStyle, runOn(this, this.u0));
                }
                break;
            case GeographicShapeSeriesBase.$$p[2]:
                this.t5.ul = this.uf;
                break;
            case GeographicShapeSeriesBase.$$p[3]:
                this.t5.vl = this.up;
                break;
            case GeographicShapeSeriesBase.$$p[4]:
                this.t5.vm = this.uq;
                break;
            case "ShapefileDataSource":
                if (c != null) {
                    var i = c;
                    if (this.uj) {
                        i.importCompleted = delegateRemove(i.importCompleted, runOn(this, this.u2));
                    }
                }
                if (d != null) {
                    var j = d;
                    if (j.count > 0) {
                        this.u3();
                        break;
                    }
                    this.uj = true;
                    j.importCompleted = delegateCombine(j.importCompleted, runOn(this, this.u2));
                }
                break;
        }
    };
    GeographicShapeSeriesBase.prototype.u1 = function (a, b) {
        if (this.assigningShapeStyle != null) {
            this.assigningShapeStyle(this, b);
        }
    };
    GeographicShapeSeriesBase.prototype.u0 = function (a, b) {
        if (this.assigningShapeMarkerStyle != null) {
            this.assigningShapeMarkerStyle(this, b);
        }
    };
    GeographicShapeSeriesBase.prototype.u2 = function (a, b) {
        this.u3();
    };
    GeographicShapeSeriesBase.prototype.u3 = function () {
        var sds_ = this.ui;
        var ext_ = sds_.externalObject;
        this.itemsSource = (ext_.getPointData());
    };
    Object.defineProperty(GeographicShapeSeriesBase.prototype, "ui", {
        get: function () {
            return this.uh;
        },
        set: function (a) {
            var b = this.uh;
            this.uh = a;
            if (b != this.uh) {
                this.raisePropertyChanged("ShapefileDataSource", b, this.uh);
            }
        },
        enumerable: false,
        configurable: true
    });
    GeographicShapeSeriesBase.prototype.get_gg = function () {
        return true;
    };
    GeographicShapeSeriesBase.prototype.set_gg = function (a) {
        _super.prototype.set_gg.call(this, a);
    };
    GeographicShapeSeriesBase.$t = markType(GeographicShapeSeriesBase, 'GeographicShapeSeriesBase', GeographicMapSeriesHost.$);
    GeographicShapeSeriesBase.$$p = markDep(DependencyProperty, PropertyMetadata, GeographicShapeSeriesBase, 'raisePropertyChanged', ['IsCustomShapeMarkerStyleAllowed:um:u4', [0, false], 'IsCustomShapeStyleAllowed:un:u5', [0, false], 'ItemSearchMode:uf:u6', [ShapeItemSearchMode_$type, enumGetBox(ShapeItemSearchMode_$type, 0)], 'ItemSearchPointsThreshold:up:u7', [1, 10000], 'ItemSearchThreshold:uq:u8', [1, 10000], 'ShapeFilterResolution:uo:u9', [1, 2], 'ShapeMemberPath:uy:va', [2, "points"]]);
    return GeographicShapeSeriesBase;
}(GeographicMapSeriesHost));
export { GeographicShapeSeriesBase };
/**
 * @hidden
 */
var GeographicShapeSeriesBaseView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(GeographicShapeSeriesBaseView, _super);
    function GeographicShapeSeriesBaseView(a) {
        var _this = _super.call(this, a) || this;
        _this.ch = null;
        _this.ch = a;
        return _this;
    }
    GeographicShapeSeriesBaseView.prototype.b5 = function () {
        _super.prototype.b5.call(this);
        this.ch.t5.vy = this.ch.uy;
    };
    GeographicShapeSeriesBaseView.prototype.ci = function () {
        var a = this.ch.t5;
        if (this.ch.cv == null) {
            a.uf = null;
            a.uh = null;
            return;
        }
        a.uf = this.ch.cv.ue;
        a.uh = this.ch.cv.ug;
    };
    GeographicShapeSeriesBaseView.prototype.ck = function () {
        this.ch.t5.vy = this.ch.uy;
    };
    GeographicShapeSeriesBaseView.prototype.cj = function () {
        this.ch.t5.vi = this.ch.uo;
    };
    GeographicShapeSeriesBaseView.$t = markType(GeographicShapeSeriesBaseView, 'GeographicShapeSeriesBaseView', HostSeriesView.$);
    return GeographicShapeSeriesBaseView;
}(HostSeriesView));
export { GeographicShapeSeriesBaseView };
