import { ImageTilesReadyEventArgs as ImageTilesReadyEventArgs_internal } from "./ImageTilesReadyEventArgs";
var IgcImageTilesReadyEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgcImageTilesReadyEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgcImageTilesReadyEventArgs.prototype.createImplementation = function () {
        return new ImageTilesReadyEventArgs_internal();
    };
    Object.defineProperty(IgcImageTilesReadyEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcImageTilesReadyEventArgs.prototype.onImplementationCreated = function () {
    };
    IgcImageTilesReadyEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    return IgcImageTilesReadyEventArgs;
}());
export { IgcImageTilesReadyEventArgs };
