import { __extends } from "tslib";
import { IgcGeographicMapImagery } from "./igc-geographic-map-imagery";
import { OpenStreetMapImagery as OpenStreetMapImagery_internal } from "./OpenStreetMapImagery";
/**
 * UI element class used to display OpenStreetMap imagery in the IgxGeographicMap.Component
*/
var IgcOpenStreetMapImagery = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcOpenStreetMapImagery, _super);
    function IgcOpenStreetMapImagery() {
        return _super.call(this) || this;
    }
    IgcOpenStreetMapImagery.prototype.createImplementation = function () {
        return new OpenStreetMapImagery_internal();
    };
    Object.defineProperty(IgcOpenStreetMapImagery.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcOpenStreetMapImagery.prototype, "tilePath", {
        /**
         * Gets or sets the tile path URL.
        */
        get: function () {
            return this.i.tilePath;
        },
        set: function (v) {
            this.i.tilePath = v;
        },
        enumerable: false,
        configurable: true
    });
    return IgcOpenStreetMapImagery;
}(IgcGeographicMapImagery));
export { IgcOpenStreetMapImagery };
