import { __extends } from "tslib";
import { IgCollection } from "igniteui-webcomponents-core";
import { SyncableObservableCollection$2 } from "igniteui-webcomponents-core";
import { String_$type } from "igniteui-webcomponents-core";
var IgcSubDomainsCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcSubDomainsCollection, _super);
    function IgcSubDomainsCollection(list) {
        var _this = _super.call(this) || this;
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgcSubDomainsCollection.prototype._createInnerColl = function () {
        var coll = new SyncableObservableCollection$2(String_$type, String_$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext;
        };
        coll.createFrom = function (int) {
            return int;
        };
        return coll;
    };
    return IgcSubDomainsCollection;
}(IgCollection));
export { IgcSubDomainsCollection };
