import { __extends } from "tslib";
import { IgcGeographicMapImagery } from "./igc-geographic-map-imagery";
import { TileGeneratorMapImagery as TileGeneratorMapImagery_internal } from "./TileGeneratorMapImagery";
/**
 * Represents a CustomMapImagery MapImagery
*/
var IgcTileGeneratorMapImagery = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcTileGeneratorMapImagery, _super);
    function IgcTileGeneratorMapImagery() {
        return _super.call(this) || this;
    }
    IgcTileGeneratorMapImagery.prototype.createImplementation = function () {
        return new TileGeneratorMapImagery_internal();
    };
    Object.defineProperty(IgcTileGeneratorMapImagery.prototype, "i", {
        /**
                                     * @hidden
                                     */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcTileGeneratorMapImagery.prototype, "tileGenerator", {
        /**
         * Gets or sets the culture name for this tile source.
        */
        get: function () {
            return this.i.tileGenerator;
        },
        set: function (v) {
            this.i.tileGenerator = v;
        },
        enumerable: false,
        configurable: true
    });
    return IgcTileGeneratorMapImagery;
}(IgcGeographicMapImagery));
export { IgcTileGeneratorMapImagery };
