import { GeographicXYTriangulatingSeriesView } from "./GeographicXYTriangulatingSeriesView";
import { SeriesView } from "igniteui-webcomponents-charts";
import { Series } from "igniteui-webcomponents-charts";
import { ScatterContourSeries } from "igniteui-webcomponents-charts";
import { Type } from "igniteui-webcomponents-core";
import { GeographicXYTriangulatingSeries } from "./GeographicXYTriangulatingSeries";
import { ValueBrushScale } from "igniteui-webcomponents-charts";
import { ContourValueResolver } from "igniteui-webcomponents-charts";
import { TriangulationStatusEventArgs } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export declare class GeographicContourLineSeriesView extends GeographicXYTriangulatingSeriesView {
    static $t: Type;
    constructor(a: GeographicContourLineSeries);
    private cp;
    au(): void;
    b5(): void;
    cq(): void;
    cr(): void;
}
/**
 * @hidden
 */
export declare class GeographicContourLineSeries extends GeographicXYTriangulatingSeries {
    static $t: Type;
    protected bc(): Series;
    protected get_ex(): boolean;
    constructor();
    protected ua(): void;
    ux: ScatterContourSeries;
    protected t4(): Series;
    private u7;
    private u8;
    u4: string;
    u0: ValueBrushScale;
    uz: ValueBrushScale;
    protected qf(): void;
    protected cd(): SeriesView;
    o2(a: SeriesView): void;
    u1: GeographicContourLineSeriesView;
    uw: ContourValueResolver;
    protected pa(a: any, b: string, c: any, d: any): void;
    triangulationStatusChanged: (sender: any, args: TriangulationStatusEventArgs) => void;
    static $$p: string[];
}
