import { GeographicMapSeriesHost } from "./GeographicMapSeriesHost";
import { ShapeItemSearchMode } from "igniteui-webcomponents-charts";
import { ShapefileConverter } from "igniteui-webcomponents-core";
import { SeriesView } from "igniteui-webcomponents-charts";
import { Type } from "igniteui-webcomponents-core";
import { AssigningShapeStyleEventArgs } from "igniteui-webcomponents-charts";
import { AssigningShapeMarkerStyleEventArgs } from "igniteui-webcomponents-charts";
import { HostSeriesView } from "./HostSeriesView";
/**
 * @hidden
 */
export declare abstract class GeographicShapeSeriesBase extends GeographicMapSeriesHost {
    static $t: Type;
    protected cd(): SeriesView;
    ug: GeographicShapeSeriesBaseView;
    o2(a: SeriesView): void;
    uy: string;
    protected get_et(): boolean;
    protected get_dv(): boolean;
    un: boolean;
    um: boolean;
    protected ul: boolean;
    protected uk: boolean;
    uf: ShapeItemSearchMode;
    uq: number;
    up: number;
    assigningShapeStyle: (sender: any, args: AssigningShapeStyleEventArgs) => void;
    assigningShapeMarkerStyle: (sender: any, args: AssigningShapeMarkerStyleEventArgs) => void;
    protected pa(a: any, b: string, c: any, d: any): void;
    private u1;
    private u0;
    private u2;
    private u3;
    private uh;
    private uj;
    get ui(): ShapefileConverter;
    set ui(a: ShapefileConverter);
    uo: number;
    protected get_gg(): boolean;
    protected set_gg(a: boolean): void;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class GeographicShapeSeriesBaseView extends HostSeriesView {
    static $t: Type;
    constructor(a: GeographicShapeSeriesBase);
    private ch;
    b5(): void;
    ci(): void;
    ck(): void;
    cj(): void;
}
