import { Type } from "igniteui-webcomponents-core";
/**
 * Indicates the desired behavior for the map on resizing.
 */
export declare enum MapBackgroundTilingMode {
    /**
     * Indicates that the map should decide the desired tiling mode automatically.
     */
    Auto = 0,
    /**
     * Map will not wrap tiles around the origin.
     */
    NonWrapped = 1,
    /**
     * Map will wrap tiles around the origin.
     */
    Wrapped = 2
}
/**
 * @hidden
 */
export declare let MapBackgroundTilingMode_$type: Type;
