import { IgcGeographicMapImagery } from "./igc-geographic-map-imagery";
import { OpenStreetMapImagery as OpenStreetMapImagery_internal } from "./OpenStreetMapImagery";
/**
 * UI element class used to display OpenStreetMap imagery in the IgxGeographicMap.Component
*/
export declare class IgcOpenStreetMapImagery extends IgcGeographicMapImagery {
    protected createImplementation(): OpenStreetMapImagery_internal;
    /**
                                 * @hidden
                                 */
    get i(): OpenStreetMapImagery_internal;
    constructor();
    /**
     * Gets or sets the tile path URL.
    */
    get tilePath(): string;
    set tilePath(v: string);
}
