import { IgcGeographicMapImagery } from "./igc-geographic-map-imagery";
import { TileGeneratorMapImagery as TileGeneratorMapImagery_internal } from "./TileGeneratorMapImagery";
import { ITileGenerator } from "igniteui-webcomponents-core";
/**
 * Represents a CustomMapImagery MapImagery
*/
export declare class IgcTileGeneratorMapImagery extends IgcGeographicMapImagery {
    protected createImplementation(): TileGeneratorMapImagery_internal;
    /**
                                 * @hidden
                                 */
    get i(): TileGeneratorMapImagery_internal;
    constructor();
    /**
     * Gets or sets the culture name for this tile source.
    */
    get tileGenerator(): ITileGenerator;
    set tileGenerator(v: ITileGenerator);
}
